CREATE DEFINER = 'timesheet'@'%' TRIGGER `tbl_log_before_ins_tr_Timestamp` BEFORE INSERT ON `tbl_log`
  FOR EACH ROW
BEGIN
	SET @LogTimestamp = now();
END;

CREATE DEFINER = 'timesheet'@'%' TRIGGER `tbl_payperiodinfo_after_upd_tr` AFTER UPDATE ON `tbl_payperiodinfo`
  FOR EACH ROW
BEGIN
	
	declare username varchar(30);
    
    set username = New.user;
	
    
    IF New.SubmitTimestamp IS NOT NULL AND Old.SubmitTimestamp IS NULL Then
    	
		IF NEW.TimesheetNumber > 0 AND Old.TimesheetNumber > 0 THEN
        	insert into tbl_log (USER,ACTION,TIMESHEETNUM) 
	    	values (username,CONCAT('Timesheet Resubmitted from #', Old.TimesheetNumber, ' payid(', New.Pay_ID, ')'),New.TimesheetNumber);
        ELSE
            insert into tbl_log (USER,ACTION,TIMESHEETNUM) 
	    	values (username,CONCAT('Timesheet Submitted payid(', New.Pay_ID, ')'), New.TimesheetNumber);
    	END IF;
    
    End If;
    
    
    IF New.SubmitTimestamp IS NULL AND Old.SubmitTimestamp IS NOT NULL THEN
    	
        IF Old.ApproveTimestamp IS NULL THEN
        	insert into tbl_log (USER,ACTION,TIMESHEETNUM) 
		    values (username,CONCAT('Timesheet Denied by Supervisor    payid(', New.Pay_ID, ')'), Old.TimesheetNumber);
        ELSE
        
	        insert into tbl_log (USER,ACTION,TIMESHEETNUM) 
		    values (username,CONCAT('Timesheet Denied by Administrator payid(', New.Pay_ID, ')'), Old.TimesheetNumber);
        END IF;
        
    END IF;
    
    
    IF New.ApproveTimestamp > 0 AND Old.ApproveTimestamp IS NULL THEN
	    insert into tbl_log (USER,ACTION,TIMESHEETNUM) 
	    values (username,CONCAT('Timesheet Approved by Supervisor payid(', New.Pay_ID, ')'), New.TimesheetNumber);
	END If;
        
END;

CREATE DEFINER = 'timesheet'@'%' TRIGGER `tbl_users_after_ins_tr` AFTER INSERT ON `tbl_users`
  FOR EACH ROW
BEGIN
	declare username varchar(30);
    set username = LEFT(user(),position('@' in user())-1);
	insert into tbl_log (USER,ACTION) 
    values (username,CONCAT('New user added: ', New.NAME));
END;

CREATE DEFINER = 'timesheet'@'%' TRIGGER `tbl_users_after_upd_tr` AFTER UPDATE ON `tbl_users`
  FOR EACH ROW
BEGIN
    
    declare username varchar(30);
    set username = LEFT(user(),position('@' in user())-1);
	insert into tbl_log (USER,ACTION) 
	values (username,CONCAT('User updated: ', New.NAME));
    	
    
    If Old.PASSWORD IS NULL AND New.PASSWORD IS NOT NULL THEN
    	insert into tbl_log (USER,ACTION) 
    	values (username,CONCAT('User password set: ', New.NAME));
    
    ELSEIF Old.PASSWORD IS NOT NULL AND New.PASSWORD IS NULL THEN
		insert into tbl_log (USER,ACTION) 
    	values (username,CONCAT('User password removed: ', New.NAME));
	
    ELSEIF Old.PASSWORD != New.PASSWORD THEN
   		insert into tbl_log (USER,ACTION) 
    	values (username,CONCAT('User password changed: ', New.NAME));
	END IF;
END;

CREATE DEFINER = 'timesheet'@'%' TRIGGER `tbl_users_after_del_tr` AFTER DELETE ON `tbl_users`
  FOR EACH ROW
BEGIN
	declare username varchar(30);
    set username = LEFT(user(),position('@' in user())-1);
	insert into tbl_log (USER,ACTION) 
    values (username,CONCAT('User deleted: ', OLD.NAME));
END;


CREATE DEFINER = 'timesheet'@'%' TRIGGER `tbl_userinfo_before_upd_tr` BEFORE UPDATE ON `tbl_userinfo`
  FOR EACH ROW
BEGIN
	
    declare hoursupdated DateTime;
    set hoursupdated = now();
    
    
    If NOT Old.HrsLeft <=> NEW.HrsLeft THEN
    	set New.HrsLastUpdate = hoursupdated;
    END IF;
END;

CREATE DEFINER = 'timesheet'@'%' TRIGGER `tbl_userinfo_after_upd_tr` AFTER UPDATE ON `tbl_userinfo`
  FOR EACH ROW
BEGIN
	
    declare username varchar(30);
    set username = New.user;
    
    
    If Old.status != New.status THEN
    	insert into tbl_log (USER,ACTION) 
    	values (username,CONCAT('User status changed from ', Old.status, ' to ', New.status));
    END IF;
    
    
    If Old.IsSupervisor = 0 AND New.IsSupervisor = 1 THEN
    	insert into tbl_log (USER,ACTION) 
    	values (username,CONCAT('User granted supervisor privileges'));
    END IF;
    
    
    If Old.IsAdmin = 0 AND New.IsAdmin = 1 THEN
    	insert into tbl_log (USER,ACTION) 
    	values (username,CONCAT('User granted admin staff privileges'));
    END IF;
    
    
    If Old.Supervisor != New.Supervisor THEN
    	insert into tbl_log (USER,ACTION) 
    	values (username,CONCAT('User supervisor changed to ', New.Supervisor));
    END IF;
    
    
    If Old.HrsLeft != NEW.HrsLeft OR (Old.HrsLeft IS NULL AND New.HrsLeft IS NOT NULL) THEN
    	insert into tbl_log (USER,ACTION) 
    	values (username,CONCAT('User work study hours changed to ', New.HrsLeft));       
    END IF;
    
END;
