<?php
//------------------------------------------------------------------------------------------
// Run administrative reports and notify admin of results by email
//------------------------------------------------------------------------------------------
/*
Authored by Joshua Morris
Last Updated: 24 May 2012
Version 3.5.0
 */ 
 
require_once (__DIR__."/../include/timesheetfunctions.php");
require_once (__DIR__."/../include/configuration.php");

$db_username='timesheet_report';

// Open connection to MySQL
$connected = connectToDatabase($db_username);

// returns 0 - success, 1 - mysql connection failed, 2 - db connection failed
if($connected == 0)
{
	// Get all account lockouts for the last month
	$query = sprintf("SELECT 
		`LogID`,
		`user`,
		`LogTimestamp`,
		`Action`,
		`TimesheetNum`
		FROM 
		`tbl_log`
		where ACTION='Login failed: 3' 
		and date(LogTimestamp) between (curdate() - interval 30 day) and curdate()");
	
	$result = mysql_query($query);
	
	if(!$result)
	{
		echo "Getting lockouts failed.\n";
	}//end!result
	else
	{
		echo "Getting lockouts succeeded.\n";
		
		$users = array();
		$count = 0;
		// get results and store users to be notified
		while($row = mysql_fetch_assoc($result))
		{
			// get user's name
			$username_store[$count] = $row['user'];
			
			// get log id
			$logid_store[$count] = $row['LogID'];
			
			// get the date
			$date_store[$count] = $row['LogTimestamp'];
			
			$count++;
		
		}//end fetch row
		
		// store number of inactive users to cyle through multiple times
		$numlockouts = $count;
		
		//-----------------------------------
		// notify the admin
		//-----------------------------------
		
		$message = "=============\nAdmin Report\n=============\n\nRecent account lockouts:\n";
		
		while($count > 0)
		{
			// since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
			$count = $count - 1;
			
			$message = $message."\n\t$logid_store[$count] $username_store[$count] $date_store[$count]";
			
							
		}//endwhile
		
		// get all status changes for the last month
		$query = sprintf("SELECT 
			`LogID`,
			`user`,
			`LogTimestamp`,
			`Action`,
			`TimesheetNum`
			FROM 
			`tbl_log`
			where date(LogTimestamp) between (curdate() - interval 30 day) and curdate()
			and ACTION like 'User status changed from _ to _'");
		
		$result = mysql_query($query);
	
		if(!$result)
		{
			echo "Getting status changes failed.\n";
		}//end!result
		else
		{
			echo "Getting status changes succeeded.\n";
			
			$users = array();
			$count = 0;
			// get results and store users to be notified
			while($row = mysql_fetch_assoc($result))
			{
				// get user's name
				$username_store[$count] = $row['user'];
				
				// get log id
				$logid_store[$count] = $row['LogID'];
				
				// get the date
				$date_store[$count] = $row['LogTimestamp'];
				
				// get the action
				$action_store[$count] = $row['Action'];
				
				$count++;
			
			}//end fetch row
			
			// store number of inactive users to cyle through multiple times
			$numstatuschanges = $count;
			
			//-----------------------------------
			// notify the admin
			//-----------------------------------
			
			$message = $message."\n\nRecent status changes:\n";
			
			while($count > 0)
			{
				// since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
				$count = $count - 1;
				
				$message = $message."\n\t$logid_store[$count] $username_store[$count] $date_store[$count] $action_store[$count]";
				
								
			}//end count>0
		
			// get all new users added for the last month
			$query = "SELECT `LogID`, user,	`LogTimestamp`, `Action`, `TimesheetNum` FROM `tbl_log`
				where date(LogTimestamp) between (curdate() - interval 30 day) and curdate()
				and (ACTION like 'New user added%' or Action like 'User deleted%' or Action like 'User password%')";
										
			$result = mysql_query($query);
		
			if(!$result)
			{
				echo "Getting users changes failed.\n";
			}//end!result
			else
			{
				echo "Getting users changes succeeded.\n";
				
				$users = array();
				$count = 0;
				// get results and store users to be notified
				while($row = mysql_fetch_assoc($result))
				{
					// get user's name
					$username_store[$count] = $row['user'];
					
					// get log id
					$logid_store[$count] = $row['LogID'];
					
					// get the date
					$date_store[$count] = $row['LogTimestamp'];
					
					// get the action
					$action_store[$count] = $row['Action'];
					
					$count++;
				
				}//end fetch row
				
				// store number of inactive users to cyle through multiple times
				$numstatuschanges = $count;
				
				//-----------------------------------
				// notify the admin
				//-----------------------------------
				
				$message = $message."\n\nRecent user account changes:\n";
				
				while($count > 0)
				{
					// since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
					$count = $count - 1;
					
					$message = $message."\n\t$logid_store[$count] $username_store[$count] $date_store[$count] $action_store[$count]";
					
									
				}//end count>0
				
				//mail notifications 
				$mailed = false;
				$mailed = mail($admintoaddress, "Bi-Weekly Timesheet Admin Report", "$message.\n\nSincerely,\nTimesheet System", "From: $systemfromaddress");
				
				// check if mail succeeded
				if(!$mailed)
				{
					echo "Mail notification failed.";
				}
			}//end else !result users		
		}//end else !result status
	}//end else !result lockouts
}//end connected
?>
