<?php
//------------------------------------------------------------------------------------------
// Look up the inactive users from the timesheet database and notify their supervisors and the administrative staff by email
//------------------------------------------------------------------------------------------

/*
Authored by Joshua Morris
Last Updated: 24 May 2012
Version 3.5.0
 */ 
 
require_once (__DIR__."/../include/timesheetfunctions.php");
require_once (__DIR__."/../include/configuration.php");

$db_username='timesheet_report';

// Open connection to MySQL
$connected = connectToDatabase($db_username);

// returns 0 - success, 1 - mysql connection failed, 2 - db connection failed
if($connected == 0)
{
	// Get all inactive users who have been inactive more than one period
	$query = sprintf("SELECT * FROM vwusersnotactive where count > 1");
	
	$result = mysql_query($query);
	
	if(!$result)
	{
		echo "Gathering users to notify failed.";
	}//end!result
	else
	{
            //initiatize variables
            $employeename_store = array();
            $supervisoruser_store = array();
            $employeeuser_store = array();
            $inactivecount_store = array();

            $count = 0;
            // get results and store users to be notified
            while($row = mysql_fetch_assoc($result))
            {
                    // get employee's name
                    $employeename_store[$count] = $row['name'];

                    // get supervisor user name
                    $supervisoruser_store[$count] = $row['supervisor'];

                    // get employee user name
                    $employeeuser_store[$count] = $row['user'];

                    // get number of pay periods employee has been inactive
                    $inactivecount_store[$count] = $row['count'];

                    $count++;

            }//end fetch row

            // store number of inactive users to cyle through multiple times
            $numinactiveusers = $count;
		
            //-----------------------------------
            // notify each supervisor
            //-----------------------------------
            while($count > 0)
            {
                // since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
                $count = $count - 1;

                echo "$employeename_store[$count], supervisor $supervisoruser_store[$count]\n";
                
                //check that user has a supervisor
                if(empty($supervisoruser_store[$count]))
                {
                    echo "No supervisor for user $employeename_store[$count]";
                }else{

                    // Get supervisor email address
                    $query = sprintf("SELECT * FROM vwuserinfo where user='%s'",$supervisoruser_store[$count]);

                    $result = mysql_query($query);
                    if(!$result)
                    {
                            echo "Cannot retrieve supervisor email.";
                    }else{
                        $row = mysql_fetch_assoc($result);
                        $email = $row['emailaddress'];

                        //mail notifications 
                        $mailed = false;
                        $mailed = mail($email, "Bi-Weekly Timesheet", "This is a notification that your employee, $employeename_store[$count] ($employeeuser_store[$count]), has been inactive for at least two pay periods. If this is because they no longer work for you, please let your administrative staff know so that the employee can be properly terminated. \n\nSincerely,\nIT Staff", "From: $systemfromaddress");

                        // check if mail succeeded
                        if(!$mailed)
                        {
                                echo "Supervisor mail notification failed.";
                        }

                    }//endelse !result
                }//endelse empty

            }//end while count>0

            //-----------------------------------
            // notify administrative staff
            //-----------------------------------
            $count = $numinactiveusers; // reset count
            $inactivelist = ""; // create blank list

            while($count > 0)
            {
                    // since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
                    $count = $count - 1;

                    $inactivelist = $inactivelist."\n$employeename_store[$count] ($employeeuser_store[$count])\nsupervisor: $supervisoruser_store[$count]\n";
            }
		
		$mailed = false;
		$mailed = mail($hrtoaddress, "Bi-Weekly Timesheet Inactive Users", "The following employees are noted to be inactive in the online timesheet system:\n $inactivelist\n\nThe supervisors have been notified by email. \n\nSincerely,\nIT Staff", "From: $systemfromaddress");
		
		// check if mail succeeded
		if(!$mailed)
		{
			echo "Admin mail notification failed.";
		}
		
	
	}//end else !result
}//end connected
?>
