<?php
//----------------------------------------------------- 
// This is a collection of custom php functions used by the Timesheet program
//----------------------------------------------------- 

// ------ Variables for POST <-> Database passing ----------------------------------------------------------
$namebox = "name"; // store POST for name field
$employeeid = "id"; // store POST for employee id field
$record = "record"; // store POST for record field
$commentbox = "comments"; // store POST for comments box
$payperiod = "pp"; // store POST for currently selected pay period
$payperiod_last = "pp_last";
$payidlast = "payid"; // store POST for pay id
$periodnumber = 0;  // set periodnumber for payperiod use
$paydate = "";  // set paydate of current period (mm/dd/yy)
$status = "D"; // set to status of employee
$user_submitted = ""; // store whether user has locked the current timesheet for approval
$user_submitvalue = 0; // store user submit date
$paystart; // set to Unix timestamp value of begining of displayed pay period
$paydates = array("","","","",""); // store the pay period dates to display
$payperiods = array("","","","",""); // store the pay period numbers to display
$isuser = 0; // store the IsUser value to check if user has permission to fill out a timesheet
$issupervisor = 0; // store the IsSupervisorr value to check if user has permission to review timesheets
$log_name = "t514ne";
$log_password = "t234pe";
$sendemailnotification = 0;
$review = "review"; // store location of submit button pressed from last form
$payidstore = "payidstore"; // store location of pay_id from last form
$employeeusernamelast = "employeeidlast"; // store location for the student username to be reviewed
$payidlastclean = 0; // set to cleaned pay id from last form
$login_store = ""; // set login result variable to empty

//set timezone or error
date_default_timezone_set('America/New_York');

//set custom error handling
set_error_handler("errors");


//----------------------------------------------------- 
// Name: errors
// Description:  Custom implimentation of error handling php. Timesheet will display an error message at 
//               the top of the page.
// Called by:    trigger_error("Message.",E_USER_ERROR);
//               when an error has been detected
// Variables:    $msg is "Message." and $type is E_USER_ERROR
// Requirements: none
// Returns:      N/A - prints messages to html
//----------------------------------------------------- 

function errors($type,$msg,$file,$line,$context)
{
	//------------------------------------------
        // Entering Hours/Minutes Correctly
        //------------------------------------------
	if($msg == "Invalid Hour Value (>24)")
	{
		echo "<h2 class=\"error\">Invalid Hour Value (>24)</h2>";
	}

	if($msg == "Invalid Hour Value (<0)")
	{
		echo "<h2 class=\"error\">Invalid Hour Value (<0)</h2>";
	}

	if($msg == "Invalid Minute Value (>59)")
	{
		echo "<h2 class=\"error\">Invalid Minute Value (>59)</h2>";
	}

	if($msg == "Invalid Minute Value (<0)")
	{
		echo "<h2 class=\"error\">Invalid Minute Value (<0)</h2>";
	}

	if($msg == "Midnight Rollover Using 24 Hour Time")
	{
		echo "<h2 class=\"error\">Midnight Rollover Using 24 Hour Time</h2>";
	}

	if($msg == "Invalid Hour Value (Non-Numeric)")
	{
		echo "<h2 class=\"error\">Invalid Hour Value (Non-Numeric)</h2>";
	}

	if($msg == "Invalid Minute Value (Non-Numeric)")
	{
		echo "<h2 class=\"error\">Invalid Minute Value (Non-Numeric)</h2>";
	}

	if($msg == "Too many hours for one day.")
	{
		echo "<h2 class=\"error\">Too many hours for one day for part-time employees.</h2>";
	}
	
	if($msg == "Too many hours for one week.")
	{
		echo "<h2 class=\"error\">Too many hours for one week for part-time employees.</h2>";
	}
	
	
        // sick/vacation/code errors
	if($msg == "Invalid Code Value")
	{
		echo "<h2 class=\"error\">Invalid code value, please use one listed below.</h2>";
	}
	
	if($msg == "Invalid Sick Hours Value (<0 or >8)")
	{
		echo "<h2 class=\"error\">Invalid Sick Hours Value (<0 or >8).</h2>";
	}
	
	if($msg == "Invalid Sick Hours Value (Non-Numeric)")
	{
		echo "<h2 class=\"error\">Invalid Sick Hours Value (Non-Numeric).</h2>";
	}
	
	if($msg == "Invalid Vacation Hours Value (<0 or >8)")
	{
		echo "<h2 class=\"error\">Invalid Vacation Hours Value (<0 or >8).</h2>";
	}
	
	if($msg == "Invalid Vacation Hours Value (Non-Numeric)")
	{
		echo "<h2 class=\"error\">Invalid Vacation Hours Value (Non-Numeric).</h2>";
	}
	if($msg == "Code used but no hours marked")
	{
		echo "<h2 class=\"error\">Code used but no hours marked.</h2>";
	}

        //------------------------------------------
        // Pay Period Errors
        //------------------------------------------
	
	if($msg == "Invalid Payperiod Number: Past end of known periods, please add new payperiods.")
	{
		echo "<h2 class=\"error\">Invalid Payperiod Number: Past end of known periods, please add new payperiods.</h2>";
	}

	if($msg == "Invalid Payperiod Number: No matching pay period found.")
	{
		echo "<h2 class=\"error\">Invalid Payperiod Number: No matching pay period found.</h2>";
	}

	if($msg == "You have selected a payperiod beyond this fiscal year.")
	{
		echo "<h2 class=\"error\">You have selected a payperiod beyond this fiscal year.</h2>";
	}

        //------------------------------------------
        // User Info Errors
        //------------------------------------------	
	if($msg == "Name must be filled in.")
	{
		echo "<h2 class=\"error\">Please enter an employee name.</h2>";
	}

	if($msg == "Employee ID must be 8 digits.")
	{
            echo "<h2 class=\"error\">Employee ID must be at least 8 digits.</h2>";
	}

	if($msg == "Invalid ID Value (Non-Numeric)")
	{
            echo "<h2 class=\"error\">Invalid ID Value (Non-Numeric).</h2>";
	}
        
        //------------------------------------------
        // Database/Permission Errors
        //------------------------------------------
        
        if($msg == "No connection")
	{
            echo "<h2 class=\"error\">The Timesheet is currently unavailable (could not connect).</h2>";
        }
        
        if($msg == "Account disabled")
	{
            echo "<h2 class=\"error\">The Timesheet is currently unavailable (account disabled). Please contact IT staff to enable your account.</h2>";
        }
        
        if($msg == "Account permission")
	{
            echo "<h2 class=\"error\">The Timesheet is currently unavailable (account permission). The current login does not have access to this area. If this is in error, please contact IT staff.</h2>";
        }
        
        if($msg == "Nonvalid Login")
	{
            echo "<h2 class=\"error\">This is a restricted site, please login and enter credentials.</h2>";
            echo "<p>Return to Timesheet <a href=\"index.php\">login page</a>.</p>";
        }
        
        if($msg == "Timesheet save")
	{
            echo "<h2 class=\"error\">Timesheet save/submit failed. Timesheet information not saved nor submitted.</h2>";
        }
        
        if($msg == "Deny fail")
	{
            echo "<h2 class=\"error\">Timesheet was not able to be denied. Supervising action incomplete.</h2>";
        }
        
        if($msg == "Approve fail")
	{
            echo "<h2 class=\"error\">Timesheet was not able to be approved. Supervising action incomplete.</h2>";
        }
        
        if($msg == "Invalid action")
	{
            echo "<h2 class=\"error\">An invalid form action was performed. Results not saved or completed.</h2>";
        }
        
        if($msg == "Already approved")
	{
            echo "<h2 class=\"error\">The Timesheet has already been approved. The administrative staff must deny the timesheet before another approval or changes can be made.</h2>";
        }
        
        if($msg == "Already submitted")
	{
            echo "<h2 class=\"error\">The Timesheet is locked (already submitted). Pay period information not saved nor submitted.</h2>";
        }
        
        if($msg == "Supervisor email")
	{
            echo "<h2 class=\"error\">Supervisor email lookup failed.</h2>";
        }
        if($msg == "List employees")
	{
            echo "<h2 class=\"error\">Unable to access the list of employees.</h2>";
        }
        
        if($msg == "List supervisors")
	{
            echo "<h2 class=\"error\">Unable to access the list of supervisors.</h2>";
        }
        
        if($msg == "Hours update")
	{
            echo "<h2 class=\"error\">Employee hours update unsuccessful.</h2>";
        }
        
        if($msg == "Pending remove")
	{
            echo "<h2 class=\"error\">Unable to remove pending account from queue.</h2>";
        }
        
        if($msg == "Account creation")
	{
            echo "<h2 class=\"error\">Unable to create account.</h2>";
        }
        
        if($msg == "Account id")
	{
            echo "<h2 class=\"error\">Unable to find account id. Account creation failed.</h2>";
        }
        
        if($msg == "User info save")
	{
            echo "<h2 class=\"error\">Unable to save user information. Database save failed.</h2>";
        }
        
        //------------------------------------------
        // Timesheet Errors
        //------------------------------------------
        
        if($msg == "Not submitted")
	{
            echo "<h2 class=\"error\">The Timesheet has not been submitted by the employee. Please have the employee submit their timesheet before an approval/denial can be made. Timesheets are open to modification by the employee until submission.</h2>";
        }
        
        if($msg == "Not approved")
	{
            echo "<h2 class=\"error\">The Timesheet has not been approved by the supervisor. The supervisor may deny the timesheet and send it back to the employee for corrections.</h2>";
        }
        
        if($msg == "Invalid payrate")
	{
            echo "<h2 class=\"error\">The new pay rate must be a positive float or integer.</h2>";
        }
        
        
        
}//end function errors

//----------------------------------------------------- 
// Name: adjustPeriod
// Description:  Takes a positive or negative number and adjusts accordingly backwards or forwards
// Called by:    Timesheet when trying to figure out the pay period drop down list
// Variables:    $x = integer, periods to adjust (-3 to 2)
//               $y = current period number (1 to 26)
// Requirements: none
// Returns:      $adjusted (integer) with the value (1-26) of the new pay period number
//----------------------------------------------------- 
function adjustPeriod($x, $y)
{
	$adjusted = $y;
	if($x < 0)
	{
		for($i=$x; $i<0; $i += 1)
		{
			$adjusted = $adjusted - 1;
			if($adjusted == 0)
			{
				$adjusted = 26;
			}
		}
	}//end $x<0
	if($x > 0)
	{

		for($i=$x; $i>0; $i -=1)
		{
			$adjusted = $adjusted + 1;
			if($adjusted == 27)
			{
				$adjusted = 1;
			}
		}
	}//end $x>0
	return $adjusted;
}//end adjustPeriod

//----------------------------------------------------- 
// Name: connectToDatabase
// Description:  Attempts to connect to the MySQL database passed to it, will open a connection if succeeds.
//               It will return an error value if it fails. 
// Called by:    Timesheet when trying to connect to the database to fetch or write values
// Variables:    $db_host = the host that the database is on (i.e. localhost)
//               $db_username = the MySQL username to connect with (i.e. timesheet_user)
//               $db_password = the MySQL username's password
//               $db_database = the MySQL database to connect to
// Requirements: The connection to be closed later.
// Returns:      $connected (integer) with the values (0 - success, 1 - mysql connection failed, 2 - database connection failed)
//----------------------------------------------------- 
function connectToDatabase($db_username)
{
	// database credentials & variables
	//$db_host='.';
	$db_host='localhost';
	$db_database='timesheet';
	$db_password='compaq01';
	
	$connected = 0;
	
	// Open connection to MySQL
	//$connection = mysql_connect($db_host, $db_username, $db_password, "mysql");
	$connection = mysql_connect($db_host, $db_username, $db_password);

	if(!$connection)
	{
		// Failed to open connection to MySQL
		$connected = 1;
	}
	else
	{
		// If connection succeeds, execute the following

		// select Timesheet Database
		$connectdb = mysql_select_db($db_database);

		if(!$connectdb)
		{
			// Failed to open connection to specified database
			$connected = 2;
		}
	}//end!connection
		
	return $connected;
	// returns 0 - success, 1 - mysql connection failed, 2 - db connection failed
	
}//end connectToDatabase

//----------------------------------------------------- 
// Name: checkValidLogin
// Description:  Determines if current username/password supplied is valid 
// Called by:    Timesheet 
// Variables:    $db_username (varchar) = database username to use (e.g. user, super, admin)
//               $user (varchar) = username submitted
//               $user_pass (varchar) = user password submitted
//
// Requirements: $_POST[$log_name] and $_POST[$log_password] defined
// Returns:      boolean - true: login is valid, false: login is invalid
//----------------------------------------------------- 
function checkValidLogin($db_username, $user, $user_pass)
{
    $isvalidlogin = false;
    //----- Connect to Database -------------------------------------------------------------------

    // returns 0 - success, 1 - mysql connection failed, 2 - db connection failed
    // connection string values are found in the associated timesheetfunctions.php file
    $connected = connectToDatabase($db_username);

    if($connected == 0)
    // if connection to database suceeds
    {
    		
        //check against NULL username or password
        if(!empty($user) && !empty($user_pass))
        {
            //--- Test if login is valid ---

            // initialize password field
            $passwordsha256 = "0";

            if(!isset($_POST['encrypted']))
            // if hidden field encrypted is not set then first visit to page, encrypt password prior to display
            {
                    // sha256 hash plaintext password
                    $passwordsha256 = hash("sha256",$user_pass);

                    // write this back to POST so that it displays encrypted in html source code
                    $_POST["t234pe"] = $passwordsha256;
                    $user_pass = $passwordsha256;

            }
            // form login check query
            $query = sprintf("SELECT LoginRequest('%s','%s') as login",mysql_real_escape_string($user),mysql_real_escape_string($user_pass));

            // execute to check login: 0 = success, 1 = no username, 2 = incorrect password
            $result = mysql_query($query);

            // process results of LoginRequest
            if($result)
            // if query succeeds
            {
                    // get results
                    $row = mysql_fetch_assoc($result);

                    // store result in variable
                    $login_store = $row['login'];

                    if($login_store == 0)
                    //if success
                    {
                            $isvalidlogin = true;
                    }//endif                             
            }//end!result
        }//end if user or password =NULL	
    }//endif connected

    return $isvalidlogin;
}//endfunc checkValidLogin  


//----------------------------------------------------- 
// Name: calculateTimesheet
// Description:  Performs Timesheet hours & error checking calculations 
// Called by:    Timesheet 
// Variables:    $status (char) = whether employee is part-time, full-time (i.e. F)
//               $time_store (array) = stores the time values for each field
//               $inputstyle (array) = stores the html for each field's style settings
//               $totalhr (array) = stores the calculated total hours for each day or week field
//               $totalmin (array) = stores the calculated total minutes for each day or week field
//               $sickhr (array) = stores the sick values for each field
//               $vacationhr (array) = stores the vacation values for each field
//               $twowktotal (integer) = stores the calculated two week total
//               $calcforpost (array) = returned time values & calculated values to be read back into $_POST after the function.
//               $user_submitvalue (datetime) = stores the SubmitTimestamp value or null
//               $hrsleft_store = stores the number of work study hrs left (if equal to 9999 then employee is not work study)
//               $hrsperdaymax = stores the maximum allowed number of hours per day for part-time employees
//               $hrsperweekmax = stores the maximum allowed number of hours per week for part-time employees
//
// Requirements: trigger_error fuction enabled
// Returns:      array($calcforpost, $inputstyle, $totalhr, $totalmin, $sickhr, $vacationhr, $twowktotal)
//----------------------------------------------------- 
function calculateTimesheet($status, $time_store, $inputstyle, $totalhr, $totalmin, $sickhr, $vacationhr, $twowktotal, $sick_store, $vac_store, $code_store, $user_submitvalue, $hrsleft_store, $hrsperdaymax, $hrsperweekmax)
{
	$calcforpost = array();
	
	// ------- Perform Timesheet Calculations -----------------
	for($week=1; $week<=2; $week += 1)
	{
		// for each week, week 1 & week 2
		for($day=1; $day<=7; $day += 1)
		{
			// for every day, day 1 = Sunday to day 7 = Saturday
			$wkdy=$week.$day;
			for($block=1; $block<=3; $block += 1)
			{
				
				// calculate hour blocks except for the third if full-time 
				if($status != 'F' || $block != 3)
				{
					// for every "time block", in and out
	
					$hin=$week.$day."hin".$block;
					$min=$week.$day."min".$block;
					$hout=$week.$day."hout".$block;
					$mout=$week.$day."mout".$block;
	
					$calcforpost[$hin] = $time_store[$hin];
					$calcforpost[$min] = $time_store[$min];
					$calcforpost[$hout] = $time_store[$hout];
					$calcforpost[$mout] = $time_store[$mout];
					
					// color if timesheet locked & read only, but before errors so errors are recolored red
					if(!is_null($user_submitvalue))
					{
						$inputstyle[$hin] = "background-color: #cccccc";
						$inputstyle[$min] = "background-color: #cccccc";
						$inputstyle[$hout] = "background-color: #cccccc";
						$inputstyle[$mout] = "background-color: #cccccc";
					}					
	
					// calculate hours if the block has a time
					if($calcforpost[$hin] != "" && $calcforpost[$hout] != "")
					{
						// check if valid hour value ---
						if($calcforpost[$hin] > 24)
						{
							trigger_error("Invalid Hour Value (>24)",E_USER_ERROR);
							$inputstyle[$hin] = "background-color: #FF0000";
						}
						if($calcforpost[$hout] > 24)
						{
							trigger_error("Invalid Hour Value (>24)",E_USER_ERROR);
							$inputstyle[$hout] = "background-color: #FF0000";
						}
						if($calcforpost[$hin] < 0)
						{
							trigger_error("Invalid Hour Value (<0)",E_USER_ERROR);
							$inputstyle[$hin] = "background-color: #FF0000";
						}
						if($calcforpost[$hout] < 0)
						{
							trigger_error("Invalid Hour Value (<0)",E_USER_ERROR);
							$inputstyle[$hout] = "background-color: #FF0000";
						}
						if($calcforpost[$hin] > 12 && $calcforpost[$hout] < 12)
						{
							trigger_error("Midnight Rollover Using 24 Hour Time",E_USER_ERROR);
							$inputstyle[$hin] = "background-color: #FF0000";
							$inputstyle[$hout] = "background-color: #FF0000";
						}
						if($calcforpost[$hin] != strval(intval($calcforpost[$hin])))
						{
							trigger_error("Invalid Hour Value (Non-Numeric)",E_USER_ERROR);
							$inputstyle[$hin] = "background-color: #FF0000";
						}
						if($calcforpost[$hout] != strval(intval($calcforpost[$hout])))
						{
							trigger_error("Invalid Hour Value (Non-Numeric)",E_USER_ERROR);
							$inputstyle[$hout] = "background-color: #FF0000";
						}
						// --- end check if valid hour value ---
		
						// add this block to the day's hours
						$totalhr[$wkdy] += ($calcforpost[$hout] - $calcforpost[$hin]);
		
						// account for am, pm -- assumes you work < 12hrs in a block
						if($calcforpost[$hin] > $calcforpost[$hout])
						{
							$totalhr[$wkdy] += 12;
						}
		
						// check for valid minutes ---
						if($calcforpost[$mout] > 59)
						{
							trigger_error("Invalid Minute Value (>59)",E_USER_ERROR);
							$inputstyle[$mout] = "background-color: #FF0000";
						}
						if($calcforpost[$min] > 59)
						{
							trigger_error("Invalid Minute Value (>59)",E_USER_ERROR);
							$inputstyle[$min] = "background-color: #FF0000";
						}
						if($calcforpost[$mout] < 0)
						{
							trigger_error("Invalid Minute Value (<0)",E_USER_ERROR);
							$inputstyle[$mout] = "background-color: #FF0000";
						}
						if($calcforpost[$min] < 0)
						{
							trigger_error("Invalid Minute Value (<0)",E_USER_ERROR);
							$inputstyle[$min] = "background-color: #FF0000";
						}
						if($calcforpost[$min] != strval(intval($calcforpost[$min])))
						{
							trigger_error("Invalid Minute Value (Non-Numeric)",E_USER_ERROR);
							$inputstyle[$min] = "background-color: #FF0000";
						}
						if($calcforpost[$mout] != strval(intval($calcforpost[$mout])))
						{
							trigger_error("Invalid Minute Value (Non-Numeric)",E_USER_ERROR);
							$inputstyle[$mout] = "background-color: #FF0000";
						}
						// --- end check for valid minutes ---
		
		
						// calculate minutes
						$totalmin[$wkdy] += ($calcforpost[$mout] - $calcforpost[$min]);
						if($calcforpost[$mout] < $calcforpost[$min])
						{
							$totalmin[$wkdy] += 60;
							$totalhr[$wkdy] -= 1;
						}
					}//end if hour has time
				}//endnotthirdifstatusF
			}//end for block
			
			while($totalmin[$wkdy] >= 60)
			{
				$totalmin[$wkdy] -= 60;
				$totalhr[$wkdy] += 1;
			}
			
			// Convert to tenths of hours using University rounding rules
			if($totalmin[$wkdy] < 3)
			{
				$totalmin[$wkdy] = 0;
			}
			else if($totalmin[$wkdy] < 9)
			{
				$totalmin[$wkdy] = 1;
			}
			else if($totalmin[$wkdy] < 15)
			{
				$totalmin[$wkdy] = 2;
			}
			else if($totalmin[$wkdy] < 21)
			{
				$totalmin[$wkdy] = 3;
			}
			else if($totalmin[$wkdy] < 27)
			{
				$totalmin[$wkdy] = 4;
			}
			else if($totalmin[$wkdy] < 33)
			{
				$totalmin[$wkdy] = 5;
			}
			else if($totalmin[$wkdy] < 39)
			{
				$totalmin[$wkdy] = 6;
			}
			else if($totalmin[$wkdy] < 45)
			{
				$totalmin[$wkdy] = 7;
			}
			else if($totalmin[$wkdy] < 51)
			{
				$totalmin[$wkdy] = 8;
			}
			else if($totalmin[$wkdy] < 57)
			{
				$totalmin[$wkdy] = 9;
			}
			else
			{
				$totalmin[$wkdy] = 0;
				$totalhr[$wkdy]++;
			}
			
			// Process Sick/Vacation/Code if Full Time
			if($status == 'F')
			{
				//--- Process Sick & Vacation Time ---
				$wkdysick = $week.$day."sick";
				$wkdyvac = $week.$day."vac";
				$wkdycode = $week.$day."code";
				$wktotal = $week."8";
	
				// load values
				$calcforpost[$wkdysick] = $sick_store[$wkdysick];
				$calcforpost[$wkdyvac] = $vac_store[$wkdyvac];
				$calcforpost[$wkdycode] = $code_store[$wkdycode];
				
				// color if timesheet locked & read only, but before errors so errors are recolored red
				if(!is_null($user_submitvalue))
				{
					$inputstyle[$wkdysick] = "background-color: #cccccc";
					$inputstyle[$wkdyvac] = "background-color: #cccccc";
					$inputstyle[$wkdycode] = "background-color: #cccccc";					
				}
	
				// error check sick hours
				if($calcforpost[$wkdysick] < 0 || $calcforpost[$wkdysick] > 8)
				{
					trigger_error("Invalid Sick Hours Value (<0 or >8)",E_USER_ERROR);
					$inputstyle[$wkdysick] = "background-color: #FF0000";
				}
				if($calcforpost[$wkdysick] != strval(floatval($calcforpost[$wkdysick])) && $calcforpost[$wkdysick] != "")
				{
					trigger_error("Invalid Sick Hours Value (Non-Numeric)",E_USER_ERROR);
					$inputstyle[$wkdysick] = "background-color: #FF0000";
				}
				else
				{
					// add sick hour to total
					$sickhr[$wktotal] += $calcforpost[$wkdysick];
				}
	
				// error check vacation hours
				if($calcforpost[$wkdyvac] < 0 || $calcforpost[$wkdyvac] > 8)
				{
					trigger_error("Invalid Vacation Hours Value (<0 or >8)",E_USER_ERROR);
					$inputstyle[$wkdyvac] = "background-color: #FF0000";
				}
				if($calcforpost[$wkdyvac] != strval(floatval($calcforpost[$wkdyvac])) && $calcforpost[$wkdyvac] != "")
				{
					trigger_error("Invalid Vacation Hours Value (Non-Numeric)",E_USER_ERROR);
					$inputstyle[$wkdyvac] = "background-color: #FF0000";
				}
				else
				{
					// add vacation hour to total
					$vacationhr[$wktotal] += $calcforpost[$wkdyvac];
				}
	
				// error check code values
				if($calcforpost[$wkdycode] != 'M' && $calcforpost[$wkdycode] != 'J' && $calcforpost[$wkdycode] != 'H' && $calcforpost[$wkdycode] != 'CT' && $calcforpost[$wkdycode] != 'LWP' && $calcforpost[$wkdycode] != 'FML' && $calcforpost[$wkdycode] != "")
				{
					trigger_error("Invalid Code Value",E_USER_ERROR);
					$inputstyle[$wkdycode] = "background-color: #FF0000";
				}
			
				// error check if code used but no hours marked
				if($calcforpost[$wkdyvac] == '' && $calcforpost[$wkdysick] == '' && $calcforpost[$wkdycode] != '')
				{
					trigger_error("Code used but no hours marked",E_USER_ERROR);
					$inputstyle[$wkdycode] = "background-color: #FF0000";
				}
			
				//--- End Process Sick & Vacation Time ---
			
				//--- Week Calculations for Full Time ---
				
				// check total hours for day are realistic and that total hours & sick/vaction time do not conflict
				if($totalhr[$wkdy] + $calcforpost[$wkdysick] + $calcforpost[$wkdyvac] + $totalmin[$wkdy] * 0.1 > 8 )
				{
					trigger_error("Too many hours for one day.",E_USER_ERROR);
				
					//check if blocks have values before highlighting
					if($totalhr[$wkdy] != 0 || $totalmin[$wkdy] != 0)
					{
						// color boxes
						for($block=1; $block<=3; $block += 1)
						{
							// for every "time block", in and out
							$hin=$week.$day."hin".$block;
							$min=$week.$day."min".$block;
							$hout=$week.$day."hout".$block;
							$mout=$week.$day."mout".$block;
					
							$inputstyle[$hin] = "background-color: #FF0000";
							$inputstyle[$min] = "background-color: #FF0000";
							$inputstyle[$hout] = "background-color: #FF0000";
							$inputstyle[$mout] = "background-color: #FF0000";
						}
					}//endiftotalnonzero
				
					// check if wkdyvac or wkdysick have values before highlighting
					if($calcforpost[$wkdyvac] != '')
					{
						$inputstyle[$wkdyvac] = "background-color: #FF0000";
					}
					if($calcforpost[$wkdysick] != '')
					{
						$inputstyle[$wkdysick] = "background-color: #FF0000";
					}
				}
			}//endif full-time
			else
			//If part-time
			{
				
                            // check that total hours for day are realistic
                            if($totalhr[$wkdy] > $hrsperdaymax || ($totalhr[$wkdy] == $hrsperdaymax && $totalmin[$wkdy] > 0))
                            {
                                trigger_error("Too many hours for one day.",E_USER_ERROR);

                                // color boxes
                                for($block=1; $block<=3; $block += 1)
                                {
                                        // for every "time block", in and out
                                        $hin=$week.$day."hin".$block;
                                        $min=$week.$day."min".$block;
                                        $hout=$week.$day."hout".$block;
                                        $mout=$week.$day."mout".$block;

                                        $inputstyle[$hin] = "background-color: #FF0000";
                                        $inputstyle[$min] = "background-color: #FF0000";
                                        $inputstyle[$hout] = "background-color: #FF0000";
                                        $inputstyle[$mout] = "background-color: #FF0000";
                                }
                            }//endiftotalhrsiseight

			}//endelseifstatusF
			
			// Process Week Total
			$wktotal = $week."8";
			$totalhr[$wktotal] += $totalhr[$wkdy];
			$totalmin[$wktotal] += $totalmin[$wkdy];
			while($totalmin[$wktotal] > 9)
			{
				$totalhr[$wktotal] += 1;
				$totalmin[$wktotal] -= 10;
			}
			
			
			
		} //end for day
	}//end for week
	
	//check that part-time employee week is not too many hours
	if($status == 'P')
	{
		// check hrs for week 1
		$wktotal1 = "18";
		if($totalhr[$wktotal1] > $hrsperweekmax || ($totalhr[$wktotal1] == $hrsperweekmax && $totalmin[$wktotal1] > 0))
		{
			trigger_error("Too many hours for one week.",E_USER_ERROR);
		}
		
		// check hrs for week 2
		$wktotal2 = "28";
		if($totalhr[$wktotal2] > $hrsperweekmax || ($totalhr[$wktotal2] == $hrsperweekmax && $totalmin[$wktotal2] > 0))
		{
			trigger_error("Too many hours for one week.",E_USER_ERROR);
		}
	}//endif too many hours
	
	// Two Week Total for full or part time
	if($status == 'F')
	{
		// value for two week total
		$twowktotal = $totalhr[18] + $totalhr[28] + $totalmin[18]/10 + $totalmin[28]/10 + $sickhr[18] + $sickhr[28] + $vacationhr[18] + $vacationhr[28];
	}
	else
	{
		// value for two week total
		$twowktotal = $totalhr[18] + $totalhr[28] + $totalmin[18]/10 + $totalmin[28]/10;
	}
	
	return array($calcforpost, $inputstyle, $totalhr, $totalmin, $sickhr, $vacationhr, $twowktotal);

}//end calculateTimesheet

//----------------------------------------------------- 
// Name: displayTimesheet
// Description:  Prints timesheet fields in html
// Called by:    Timesheet 
// Variables:    $status (char) = whether employee is part-time, full-time (i.e. F)
//               $calcforpost (array) = returned time values & calculated values to be read back into $_POST after the function.
//               $paystart = (varchar) = beginning date of the pay period
//               $inputstyle (array) = stores the html for each field's style settings
//               $user_sumbitted (varchar) = stores the "readyonly" style if timesheet locked
//               $totalhr (array) = stores the calculated total hours for each day or week field
//               $totalmin (array) = stores the calculated total minutes for each day or week field
//               $sickhr (array) = stores the sick values for each field
//               $vacationhr (array) = stores the vacation values for each field
//   
// Requirements: trigger_error fuction enabled
// Returns:      N/A - prints table to html
//----------------------------------------------------- 
function displayTimesheet($status, $calcforpost, $paystart, $weekdays, $inputstyle, $user_submitted, $totalhr, $totalmin, $sickhr, $vacationhr)
{
	// Print Timesheet rows & columns
	
	for($week=1; $week<=2; $week += 1)
	{
		for($day=0; $day<=8; $day += 1)
		{
			// if day is 0, print header row
			if($day==0)
			{
				print("<table cellspacing='5'>");
				print("<tr>");
				print("<th><b>Week $week</b></th><th><b>Date</b></th>");
				for($count = 1; $count <= 3; $count += 1)
				{
					// print in/out headers unless full-time for the third hour block
					if($status != 'F' || $count != 3)
					{
						print("<th>In</th>");
						print("<th>Out</th>");
					}
					
				}
				print("<th>Hours</th>");
				print("<th>Tenths</th>");
				
				//print Sick/Vacation/Code only if Full Time
				if($status == 'F')
				{
					print("<th>Sick</th>");
					print("<th>Vacation</th>");
					print("<th>Code</th>");
				}
				
				print("</tr>");
			}//endif day 0
			// if day is 1 to 7 print row for day
			else if($day < 8)
			{
				if($week == 1)
				{
					// calculate date, add day # (minus one as 1 index)
					$date = mktime(0,0,0,date("m",$paystart),date("d",$paystart)+$day-1,date("Y",$paystart));
				}
				else
				{
					// adjust day for week 2, add day # plus 7 (minus one as 1 index)
					$date = mktime(0,0,0,date("m",$paystart),date("d",$paystart)+$day+6,date("Y",$paystart));
				}
				
				print("<tr>");
				print("<td>$weekdays[$day] </td><td>".date("m/d/Y",$date)."</td>\n");
				for($block=1; $block<=3; $block+=1)
				{
					
					// print hour blocks except for the third if full-time 
					if($status != 'F' || $block != 3)
					{
					
						$wkdyhin=$week.$day."hin".$block;
						$wkdymin=$week.$day."min".$block;
						$wkdyhout=$week.$day."hout".$block;
						$wkdymout=$week.$day."mout".$block;
					
						print("<td><input maxLength=\"2\" size=\"2\" name=$wkdyhin style=\"$inputstyle[$wkdyhin]\" value=\"$calcforpost[$wkdyhin]\" $user_submitted>:");
						print("<input maxLength=\"2\" size=\"2\" name=$wkdymin style=\"$inputstyle[$wkdymin]\" value=\"$calcforpost[$wkdymin]\" $user_submitted></td>\n");
						print("<td><input maxLength=\"2\" size=\"2\" name=$wkdyhout style=\"$inputstyle[$wkdyhout]\" value=\"$calcforpost[$wkdyhout]\" $user_submitted>:");
						print("<input maxLength=\"2\" size=\"2\" name=$wkdymout style=\"$inputstyle[$wkdymout]\" value=\"$calcforpost[$wkdymout]\" $user_submitted></td>\n");
					}
				}
				$wkdaynum = $week.$day;
				
				//Print Sick/Vacation/Code if Full Time
				if($status == 'F')
				{
					$sickfield = $week.$day."sick";
					$vacfield = $week.$day."vac";
					$codefield = $week.$day."code";
				}
				
				print("<td align=\"center\"><input class=\"total\" size=\"2\" name=wk{$week}day{$day}hrtotal value=\"$totalhr[$wkdaynum]\" readonly></td>");
				print("<td align=\"center\"><input class=\"total\" size=\"2\" name=wk{$week}day{$day}mintotal value=\"$totalmin[$wkdaynum]\" readonly>");
				
				// Print Sick/Vacation/Code if Full Time
				if($status == 'F')
				{
					print("<td align=\"center\"><input maxLength=\"3\" size=\"3\" name=\"$sickfield\" style=\"$inputstyle[$sickfield]\" value=\"$calcforpost[$sickfield]\" $user_submitted></td>");
					print("<td align=\"center\"><input maxLength=\"3\" size=\"3\" name=\"$vacfield\" style=\"$inputstyle[$vacfield]\" value=\"$calcforpost[$vacfield]\" $user_submitted></td>");
					print("<td align=\"center\"><input maxLength=\"3\" size=\"3\" name=\"$codefield\" style=\"$inputstyle[$codefield]\" value=\"$calcforpost[$codefield]\" $user_submitted>");
				}
				print("</td></tr>\n\n");
				
				
			}//endelse day < 8
			// if day is 8, print total row
			else
			{
				print("<tr>");
				print("<td><b>Total</b><td></td>\n");
				for($count=0; $count < 6; $count+=1)
				{
					// print spacer tables except for last two if full-time
					if($status != 'F' || ($count != 5 && $count != 4))
					{
						print("<td></td>");
					}
				}
				$weektotal = $week."8";
				print("<td align=\"center\"><input size=\"2\" class=\"total\" name=wk{$week}hrtotal value=\"$totalhr[$weektotal]\" readonly></td>");
				print("<td align=\"center\"><input size=\"2\" class=\"total\" name=wk{$week}mintotal value=\"$totalmin[$weektotal]\" readonly></td>");
				
				// Print Sick/Vacation/Code if Full Time
				if($status == 'F')
				{
					print("<td align=\"center\"><input size=\"2\" class=\"total\" name=wk{$week}sicktotal value=\"$sickhr[$weektotal]\" readonly</td>");
					print("<td align=\"center\"><input size=\"2\" class=\"total\" name=wk{$week}vactotal value=\"$vacationhr[$weektotal]\" readonly></td>");
				}
				
				print("</tr></table>\n\n");
			}//endforday8
		}//endforday
	}//endforweek
	
}//end displayTimesheet

//----------------------------------------------------- 
// Name: displayNameIdRecord
// Description:  Prints name, employeeid, and record fields in html
// Called by:    Timesheet 
// Variables:    $user_sumbitvalue (datetime) = stores the submit timestamp, if null then no submission for current period
//               $namebox (varchar) = stores location of name
//               $employeeid (varchar) = stores location of employee id number
//               $record (varchar) = stores location of record number
//               $userinfoforpost (array) = stores the POST values for name, employeeid, record
//   
// Requirements: trigger_error fuction enabled
// Returns:      N/A - prints form fields to html
//----------------------------------------------------- 
function displayNameIdRecord($user_submitvalue, $namebox, $employeeid, $record, $userinfoforpost)
{
	// styles default to clear
	$inputstyle[$namebox] = "";
	$inputstyle[$employeeid] = "";
	$inputstyle[$record] = "";
		
	// color gray if read only
	if(!is_null($user_submitvalue))
	{
		$inputstyle[$namebox] = "background-color: #cccccc";
		$inputstyle[$employeeid] = "background-color: #cccccc";
		$inputstyle[$record] = "background-color: #cccccc";
		$user_submitted = "readOnly";
	}
	
	// color boxes red if empty or error
	if(! isset($userinfoforpost[$namebox]) || ! isset($userinfoforpost[$employeeid]))
	{
		print("<h2>Please enter Name and Employee ID.</h2>");
		if(!isset($userinfoforpost[$namebox]))
		{
			$inputstyle[$namebox] = "background-color: #FF0000";
		}
		else
		{
			$inputstyle[$employeeid] = "background-color: #FF0000";
		}
	}
	else
	{
	
		if(strlen($userinfoforpost[$namebox]) < 1)
		// if name has less than 1 character, color box
		{
			$inputstyle[$namebox] = "background-color: #FF0000";
			trigger_error("Name must be filled in.",E_USER_ERROR);
		}
		if(strlen($userinfoforpost[$employeeid]) < 8)
		// if employee id is less than 8 digits, color box
		{
			$inputstyle[$employeeid] = "background-color: #FF0000";
			trigger_error("Employee ID must be 8 digits.",E_USER_ERROR);
		}
		if($userinfoforpost[$employeeid] != strval(intval($userinfoforpost[$employeeid])))
		{
			$inputstyle[$employeeid] = "background-color: #FF0000";
			trigger_error("Invalid ID Value (Non-Numeric)",E_USER_ERROR);
		}
	}
		
	// print name and employee id boxes
	print("<p>Name: <input maxLength=\"30\" size=\"30\" name=$namebox style=\"$inputstyle[$namebox]\" value=\"$userinfoforpost[$namebox]\" $user_submitted>");
	print(" Employee ID Number: <input maxLength=\"9\" size=\"9\" name=$employeeid style=\"$inputstyle[$employeeid]\" value=\"$userinfoforpost[$employeeid]\" $user_submitted>");
	print(" Record #: <input maxLength=\"1\" size=\"1\" name=$record style=\"$inputstyle[$record]\" value=\"$userinfoforpost[$record]\" $user_submitted></p>\n\n");
		
}//end displayNameIdRecord
//----------------------------------------------------- 
// Name: displayNameIdRecordEmail
// Description:  Prints name, employeeid, record, and email fields in html
// Called by:    Timesheet 
// Variables:    $user_sumbitvalue (datetime) = stores the submit timestamp, if null then no submission for current period
//               $namebox (varchar) = stores location of name
//               $employeeid (varchar) = stores location of employee id number
//               $record (varchar) = stores location of record number
//               $userinfoforpost (array) = stores the POST values for name, employeeid, record, and email
//               $count (integer) = stores index to add to POST fields (allows multiple calls to be unique)
//   
// Requirements: trigger_error fuction enabled
// Returns:      N/A - prints form fields to html
//----------------------------------------------------- 
function displayNameIdRecordEmail($user_submitvalue, $namebox, $employeeid, $record, $emailaddress, $userinfoforpost, $count)
{
	// styles default to clear
	$inputstyle[$namebox] = "";
	$inputstyle[$employeeid] = "";
	$inputstyle[$record] = "";
        $inputstyle[$emailaddress] = "";
		
	// color gray if read only
	if(!is_null($user_submitvalue))
	{
		$inputstyle[$namebox] = "background-color: #cccccc";
		$inputstyle[$employeeid] = "background-color: #cccccc";
		$inputstyle[$record] = "background-color: #cccccc";
		$user_submitted = "readOnly";
	}

        if(strlen($userinfoforpost[$namebox]) < 1 || empty($userinfoforpost[$namebox]))
        // if name has less than 1 character, color box
        {
                $inputstyle[$namebox] = "background-color: #FF0000";
                trigger_error("Name must be filled in.",E_USER_ERROR);
        }
        if(strlen($userinfoforpost[$employeeid]) < 8 || empty($userinfoforpost[$employeeid]))
        // if employee id is less than 8 digits, color box
        {
                $inputstyle[$employeeid] = "background-color: #FF0000";
                trigger_error("Employee ID must be 8 digits.",E_USER_ERROR);
        }
        if($userinfoforpost[$employeeid] != strval(intval($userinfoforpost[$employeeid])))
        {
                $inputstyle[$employeeid] = "background-color: #FF0000";
                trigger_error("Invalid ID Value (Non-Numeric)",E_USER_ERROR);
        }
		
	// print name and employee id boxes
	print("<p><input type=\"hidden\" name=\"user".$count."\" value=\"".$userinfoforpost['user']."\">");
        print("Name: <input maxLength=\"30\" size=\"30\" name=\"".$namebox.$count."\" style=\"$inputstyle[$namebox]\" value=\"$userinfoforpost[$namebox]\" $user_submitted>");
	print(" Employee ID Number: <input maxLength=\"9\" size=\"9\" name=\"".$employeeid.$count."\" style=\"$inputstyle[$employeeid]\" value=\"$userinfoforpost[$employeeid]\" $user_submitted>");
	print(" Record #: <input maxLength=\"1\" size=\"1\" name=\"".$record.$count."\" style=\"$inputstyle[$record]\" value=\"$userinfoforpost[$record]\" $user_submitted>");
        print(" Email Address: <input maxLength=\"45\" size=\"45\" name=\"emailaddress$count\" style=\"$inputstyle[$email]\" value=\"$userinfoforpost[$emailaddress]\" $user_submitted></p>\n\n");
		
}//end displayNameIdRecordEmail

//----------------------------------------------------- 
// Name: displayPayPeriodDropDown
// Description:  Prints Pay Period line with dropdown and change button in html
// Called by:    Timesheet 
// Variables:    $selected_period (varchar) = stores the last period from POST
//               $payperiod (varchar) = stores location of selected period in POST
//               $paydates (array) = stores pay date values from tbl_periodnum
//               $payperiods (array) = stores pay period numbers from tbl_periodnum
//               $maxpayperiod (integer) = stores maximum pay period allowed, set by configuration
// Requirements: 
// Returns:      N/A - prints form fields to html
//----------------------------------------------------- 
function displayPayPeriodDropDown($selected_period, $payperiod, $paydates, $payperiods, $maxpayperiod)
{
	$paystart = 0;

	// maintain previous dropdown selection; if not set autoset to closest pay period
	if(! isset($selected_period))
	{
		$selected_period = $paydates[3];
	}
	
	// initialize t values to mark which to default to selected in drop down
	$t1 = ""; $t2 = ""; $t3 = ""; $t4 = ""; $t5 = ""; $t6 = "";
	
	// find which drop down date to default to selected
	switch($selected_period)
	{
		case $paydates[0]:
			$t1 = "selected";
			break;
		case $paydates[1]:
			$t2 = "selected";
			break;
		case $paydates[2]:
			$t3 = "selected";
			break;
		case $paydates[3]:
			$t4 = "selected";
			break;
		case $paydates[4]:
			$t5 = "selected";
			break;
		case $paydates[5]:
			$t6 = "selected";
			break;
	}
	
	// Print pay period number
	print("<p>Pay Period: ");
	if(! isset($selected_period))
	// if no period selected default to current payperiod
	{
		print("$periodnumber");
	}
	else
	{
	
		$periodnumber_temp = 0;
		
		// determine if any listed periods are selected
		switch($selected_period)
		{
			case $paydates[0]:
				$periodnumber_temp = $payperiods[0];
				break;
			case $paydates[1]:
				$periodnumber_temp = $payperiods[1];
				break;
			case $paydates[2]:
				$periodnumber_temp = $payperiods[2];
				break;
			case $paydates[3]:
				$periodnumber_temp = $payperiods[3];
				break;
			case $paydates[4]:
				$periodnumber_temp = $payperiods[4];
				break;
			case $paydates[5]:
				$periodnumber_temp = $payperiods[5];
				break;
		}
		
		// print selected period number
		print("$periodnumber_temp");
	
		// user can select two payperiods beyond the 26th period, warn for this
		if($periodnumber_temp > $maxpayperiod && $periodnumber < $maxpayperiod + 1)
		{
			trigger_error("You have selected a payperiod beyond this fiscal year.",E_USER_ERROR);
		}
	
	}//endelse !isset $selected_period
	
	// Print drop down form - removed value=\"$selected_period\ from select
	print("&nbsp; &nbsp; &nbsp; &nbsp; Dates: <select name=\"$payperiod\">");
		print("<option value=\"".$paydates[0]."\" $t1>".$paydates[0]."</option>");
		print("<option value=\"".$paydates[1]."\" $t2>".$paydates[1]."</option>");
		print("<option value=\"".$paydates[2]."\" $t3>".$paydates[2]."</option>");
		print("<option value=\"".$paydates[3]."\" $t4>".$paydates[3]."</option>");
		print("<option value=\"".$paydates[4]."\" $t5>".$paydates[4]."</option>");
		print("<option value=\"".$paydates[5]."\" $t6>".$paydates[5]."</option>");
	print("</select> - ");
	
	// Determine selected starting date and Print ending date
	$paystart = strtotime($selected_period);
	$payend = mktime(0,0,0,date("m",$paystart),date("d",$paystart)+13,date("Y",$paystart));
	echo date("m/d/Y", $payend);
	print(" <input type=\"submit\" value=\"Change\" name=\"change\" class=\"noprint\"></p>\n\n");
	
	return $paystart;

}//end displayPayPeriodDropDown

//----------------------------------------------------- 
// Name: displayRateTotalHours
// Description:  Prints two week total, rate, and net pay in html
// Called by:    Timesheet 
// Variables:    $rate_store (integer) = stores the rate from POST
//               $twowktotal (integer) = stores the calculated two week total
//               $user_submitted (varchar) = stores if the field should be "readonly" or not
// Requirements: 
// Returns:      N/A - prints form fields to html
//----------------------------------------------------- 
function displayRateTotalHours($rate_store, $twowktotal, $user_submitted)
{
	// print rate, hour, total row
	
	// color rate box if readonly
	$style = "";
	if($user_submitted == 'readOnly')
	{
		$style = "background-color: #cccccc";
	}
	
	// print inputs
	print("<p><input size=\"4\" class=\"total\" name=\"totalhours\" value=\"$twowktotal\" readonly> Hours x ");
	printf("\$<input size=\"5\" maxLength=\"5\" name=\"rate\" style=\"background-color: #cccccc\" class=\"rate\" value=\"%.2f\" readonly>/hr = ",$rate_store);
	$pay = $twowktotal*$rate_store;
	printf("\$<input size=\"7\" class=\"total\" name=\"paytotal\" value=\"%.2f\" readonly><br><br>\n",$pay);
}//end displayRateTotalHours

//----------------------------------------------------- 
// Name: displayComments
// Description:  Prints comment box in html
// Called by:    Timesheet 
// Variables:    $comment_store (varchar) = stores the comments from POST
//               $user_submitted (varchar) = stores if the field should be "readonly" or not
//               $commentbox (varchar) = stores location of comments in POST
// Requirements: 
// Returns:      N/A - prints form fields to html
//----------------------------------------------------- 
function displayComments($comment_store, $user_submitted, $commentbox, $status)
{
	// print comments line
	print("Comments:  <br>");
	
	// print comments as text on printed page
	print("<p class=\"noscreen\">");
	print_r($comment_store);
	print("</p>\n");
	
	// color comments box if readonly
	$style = "";
	if($user_submitted == "readOnly")
	{
		$style = "background-color: #cccccc";
	}
		
	// print textbox to screen
	print("<table class=\"noprint\" cellspacing=\"25\"><tr><td><textarea class=\"noprint\" name=\"$commentbox\" style=\"$style\" rows=\"6\" cols=\"65\" $user_submitted>$comment_store</textarea></td><td>");
	
	if($status == 'F')
	{
	print("Codes:<br>M = Military<br>J = Jury Duty<br>H = Holiday Pay<br>CT = Compensatory Time<br>LWP = Leave without
	  Pay<br>FML = Family and Medical Leave");
	}
	print("</td></tr></table><br><br><br>\n");	
	
}//end 

//----------------------------------------------------- 
// Name: emailNotify
// Description:  Checks user's email settings and message code to sends an email notification
// Called by:    Timesheet 
// Variables:    $user (varchar) = stores the username of who called the function 
//               $to (varchar) = stores the username of who to email
//               $from (varchar) = stores the email address for the FROM field
//               $userfullname = stores the full name of the user who called the function
//               $perioddate = stores date of relevant pay period (mm/dd/yy)
//               $messagetype (integer) = stores the message type to send
//                  1 = employee has submitted timesheet
//                  2 = supervisor has denied timesheet
//                  3 = administrative staff denied timesheet
// Requirements: database connection must already be active.
// Returns:      print message if mail failure
//----------------------------------------------------- 
function emailNotify($user, $to, $from, $userfullname, $perioddate, $messagetype)
{

	
	// check if notification of employee submitting timesheet
	if($messagetype == 1)
	{
		// get supervisor email settings to notify supervisor
		$query = "SELECT * FROM vwemail WHERE user = '$to'";
		// run query
		$result = mysql_query($query);

		if($result)
		{
			// get result
			$row = mysql_fetch_assoc($result);
	
			$superemailsetting = $row['email'];
                        $emailaddress = $row['emailaddress'];
	
			// 0 = no notifications
			if($superemailsetting > 0)
			{
				$mailed = false;
				$mailed = mail("$emailaddress", "Bi-Weekly Timesheet", "This is a notification that your employee, $userfullname ($user), submitted their timesheet for pay period $perioddate.\n\n", "From: $from");

				// check if mail succeeded
				if(!$mailed)
				{
					echo "<p>Mail failed.</p>";
				}
			}//end check email setting
		}//end check result on super email lookup
	}//end messagetype=1
	
	// check if notification of supervisor denying employee timesheet
	if($messagetype == 2)
	{
		// get employee email settings
		$query = "SELECT * FROM vwemail WHERE user = '$to'";
		// run query
		$result = mysql_query($query);

		if($result)
		{
			// get result
			$row = mysql_fetch_assoc($result);
	
			$employeeemailsetting = $row['email'];
                        $emailaddress = $row['emailaddress'];
	
			// 0 = no notifications
			if($employeeemailsetting > 0)
			{
				// compose message
				$mailed = false;
				$mailed = mail("$emailaddress", "Bi-Weekly Timesheet", "This is a notification that your supervisor, $userfullname ($user), has denied your timesheet for the pay period $perioddate. If you do not know the reason for this please contact your supervisor so that the appropriate corrections can be made.", "From: $from");

				// check if mail succeeded
				if(!$mailed)
				{
					echo "<p>Mail failed.</p>";
				}
			}//end check email setting
		}//end check result on super email lookup
	}//end messagetype=2
	
	// check if notification of staff denying employee timesheet
	if($messagetype == 3)
	{
		// get employee email settings
		$query = "SELECT * FROM vwemail WHERE user = '$to'";
		// run query
		$result = mysql_query($query);

		if($result)
		{
			// get result
			$row = mysql_fetch_assoc($result);
	
			$employeeemailsetting = $row['email'];
                        $emailaddress = $row['emailaddress'];
	
			// 0 = no notifications
			if($employeeemailsetting > 0)
			{
				
				$mailed = false;
				$mailed = mail("$emailaddress", "Bi-Weekly Timesheet", "This is a notification that the administrative staff, $userfullname ($user), has denied your timesheet for the pay period $perioddate. If you do not know the reason for this please contact your supervisor so that the appropriate corrections can be made.", "From: $from");

				// check if mail succeeded
				if(!$mailed)
				{
					echo "<p>Mail failed.</p>";
				}
			}//end check email setting
		}//end check result on super email lookup
	}//end messagetype=3
}//end emailNotify

//----------------------------------------------------- 
// Name: calcPayPeriodInfo
// Description:  Calculates current pay period information based on current date
// Called by:    Timesheet 
// Variables:    $paydates (array) = stores pay dates of the current period, the previous three, and next two
//               $payperiods (array) = stores the pay periods for the current period, the previous three, and the next two
//               $paydate (varchar) = stores the current period start date
//               $periodnumber (integer) = stores the current pay period number
// Requirements: database connection must already be active.
// Returns:      modifies all variables to fill with data
//----------------------------------------------------- 
function calcPayPeriodInfo ()
{
    $paydates = array("","","","","");
    $payperiods = array("","","","","");
    $paydate = "";
    $periodnumber = "";

    // get period numbers & dates for current view
    $query = sprintf("SELECT * FROM vwtimesheetpayperiods");

    // execute
    $result = mysql_query($query);

    if(!$result)
    {
            print("<br><h2>The Timesheet is currently unavailable (could not access pay periods). Please try again later or contact IT staff.</h2><br>");
    }

    // for every pay period in array (listed newest to oldest), read in backwards (then listed oldest to newest) 
    $count = 5;
    while ($row = mysql_fetch_assoc($result))
    {
            // store paystart date string and period integer number
            $paydates[$count] = $row["paystart"];
            $payperiods[$count] = $row["period"];
            $count--;
    }

    // set periodnumber & paydate to the current pay period values
    $periodnumber = $payperiods[3]; 
    $paydate = $paydates[3];

    if($periodnumber == 0)
    // no valid payperiod found
    {
            echo "<br><h2>Invalid pay period number, past end of known periods.<br>Please contact IT Staff</h2>";
            $periodnumber = 27;
    }

    // error checking
    if($periodnumber < 1)
    // if $periodnumber has not been changed then no matching payperiod was found
    {
            trigger_error("Invalid Payperiod Number: No matching pay period found.",E_USER_ERROR);
    }
    elseif($periodnumber > 26)
    // if number > 26 then date is later than last know pay period
    {
            trigger_error("Invalid Payperiod Number: Past end of known periods, please add new payperiods.",E_USER_ERROR);
    }
    
    $results = array($paydates, $payperiods, $paydate, $periodnumber);
    
    return $results;
    
}//end calcPayPeriodInfo
    
//----------------------------------------------------- 
// Name: printPageHeader
// Description:  prints common page header information
// Called by:    Timesheet 
// Variables:    
// Requirements: 
// Returns:      prints to screen
//----------------------------------------------------- 
function printPageHeader ()
{
    print("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">");
    print("<meta name=\"description\" content=\"Bi-weekly Timesheet for employees, supervisors, and administrative staff\">");
    print("<link rel=\"stylesheet\" type=\"text/css\" href=\"include/style.css\">");
    print("<link rel=\"stylesheet\" media=\"print\" href=\"include/print.css\" type=\"text/css\">");
    print("<link rel=\"shortcut icon\" href=\"include/favicon.ico\">");
}//end printPageHeader

//----------------------------------------------------- 
// Name: checkValidPermissions
// Description:  Checks the user's permissions and returns if valid or not
// Called by:    Timesheet 
// Variables:    
//              $user (varchar) = stores the logged in user's username
//              $role (varchar) = stores the role permission being checked ['user', 'super', 'staff']
// Requirements: 
// Returns:      true / false based on permissions
//----------------------------------------------------- 
function checkValidPermissions($user, $role)
{
    //set false until proven otherwise
    $valid = false;
    
    $query = sprintf("SELECT * FROM vwuserpermissions WHERE user = '%s'", mysql_real_escape_string($user));

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
        trigger_error("No connection",E_USER_ERROR);
    }
    else
    {
        
        $row = mysql_fetch_assoc($result); // get results
        $isstaff = $row['IsAdmin']; // store staff permission 
        $isuser = $row['IsUser']; //store user permission
        $issuper = $row['IsSupervisor']; //store supervisor permission
        $status = $row['status'];// store status permission 

        //----- Check if User Account is Disabled ---------------------------------------------------------------
        if($status == 'D')
        {
                trigger_error("Account disabled",E_USER_ERROR);
        }
        
        if($role == 'user' && $isuser == 1)
        {
            $valid = true;
        }elseif($role == 'super' && $issuper == 1)
        {
            $valid = true;
        }elseif($role == 'staff' && $isstaff == 1)
        {
            $valid = true;
        }else{
                trigger_error("Account permission",E_USER_ERROR);
        }
    }
    
    return $valid;
    
}//endfunc checkValidPermissions

//----------------------------------------------------- 
// Name: getUserEmail
// Description:  Gets the user's email address from the database
// Called by:    Timesheet 
// Variables:    
//              $user (varchar) = stores the logged in user's username
// Requirements: 
// Returns:     (varchar) the email address or emtpy string on failure
//----------------------------------------------------- 
function getUserEmail($user)
{
    $email = "";
    // Get user's email address
    $query = sprintf("SELECT * FROM vwuserinfo where user='%s'",mysql_real_escape_string($user));
    $result = mysql_query($query);
    if($result)
    {
        $row = mysql_fetch_assoc($result);
        $email = $row['emailaddress'];
    }
    return $email;
}//endfunc getUserEmail
?>


