<?php

/*
Copyright (c) 2012 Joshua Morris
Last Updated: 11 May 2012
*/

require_once "include/timesheetfunctions.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet | Request Account</title>

<style type="text/css">
#info_namedotn {
	display: none;
	position: absolute;
	left: 550px;
	top: 200px;
	border-style: solid;
	background-color: #FFFFFF;
	padding: 5px;
	margin-right: 14px;
	z-index:4;
}

#info_employeenum{
	display: none;
	position: absolute;
	left: 550px;
	top: 200px;
	border-style: solid;
	background-color: #FFFFFF;
	padding: 5px;
	margin-right: 14px;
	z-index:4;
}
</style>

<script type="text/javascript" language="JavaScript">
 <!--
  	function HideContent(d) {
  		if(d.length < 1)
  		{
  			return;
  		}
  		document.getElementById(d).style.display = "none";
  	}
  	function ShowContent(d) {
  		if(d.length < 1)
  		{
  			return;
  		}
  		document.getElementById(d).style.display = "block";
		
		HideOtherContent(d);
  	}
	function HideOtherContent(d){
		if(d == 'info_employeenum')
		{
			HideContent('info_namedotn');
		}
		else if(d == 'info_namedotn')
		{
			HideContent('info_employeenum');
		}
	}
 //-->
</script>


</head>

<body>
<!-- header container -->
<div id="container">
    <?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Request An Account</div></div>"); ?>
		
    <!-- main container -->
        <div id="content_container">
        <br>
        <p>Please fill in the form below. You will be notified when your account has been created.</p>


        <form name="timesheet_request" action="requestaccount.php" method="POST" >
        <?php

        //initialize variables 

        //track whether any reasons not to submit
        $submissionerror = false;

        //get & check saved name
        $savedname = "";
        if(isset($_POST["name"]))
        {  
            if(!empty($_POST["name"]))
            {
                $savedname = $_POST["name"];
            }else{
                print("<p style=\"color:red\">Error: Full name must be provided.</p>");
                $submissionerror = true;
            }
        }

        //get & check saved login
        $login = "";
        if(isset($_POST["login"]))
        {
            if(!empty($_POST["login"]))
            {
                $login = $_POST["login"];
            }else{
                print("<p style=\"color:red\">Error: Login name must be provided.</p>");
                $submissionerror = true;
            }
        }

        //get & check saved id
        $employeeid = ""; $empnum = "";
        if(isset($_POST["employeenum"]))
        {
            if(!empty($_POST["employeenum"]))
            {
                $employeeid = htmlentities($_POST["employeenum"]);
                $empnum = $_POST['employeenum'];
            }
        }

        //get & check password
        $password = ""; $passwordencrypted = "";
        if(isset($_POST["password"]))
        {
            if(!empty($_POST["password"]))
            {
                if(strlen($_POST["password"]) >= 8)
                //ensure minimum password length
                {
                    $password = $_POST["password"];
                    $passwordencrypted = hash("sha256",$password);
                }else{
                    print("<p style=\"color:red\">Error: Please choose a password of at least eight characters.</p>");
                    $submissionerror = true;
                }   
            }else{
                print("<p style=\"color:red\">Error: Password cannot be empty or null.</p>");
                $submissionerror = true;
            }
        }

        //get & check role
        $role = "";
        if(isset($_POST["role"]))
        {
            if(!empty($_POST["role"]))
            {
                $role = $_POST["role"];
            }else{
                print("<p style=\"color:red\">Error: Role must be provided.</p>");
                $submissionerror = true;
            }
        }

        //get & check reset
        $reset = '';
        if(isset($_POST['reset']))
        {
                $reset = 'y';
        }

        //initialize printform variable
        $printform = true;

        if(isset($_POST['request']))
        {

            //check that hidden bot field is not filled in, if so do not submit as it is spam
            if(!empty($_POST['botcheck'])) 
            {
                    echo "Bot check failed.";
            }
            elseif(! $submissionerror)       
            {
                // print confirmation
                print("Name: $savedname<br>");
                print("Login: $login<br>");
                print("Role: $role<br>");

                // database credentials & variables
                $connected = connectToDatabase('request');

                if($connected == 0)
                {
                        // success insert values into table
                        $query = sprintf("INSERT INTO tbl_account (name, user, desiredpassword, empnum, role, reset, pending) values ('%s','%s','%s','%s','%s','%s', 1)",mysql_real_escape_string($savedname),mysql_real_escape_string($login),mysql_real_escape_string($passwordencrypted),mysql_real_escape_string($empnum),mysql_real_escape_string($role), mysql_real_escape_string($reset));

                        $result = mysql_query($query);

                        // if query fails, notify
                        if(!$result)
                        {
                                echo "<p style=\"color:red\">Account request failed, please contact the IT (address@domain.edu).</p>";
                        }//end!result

                        // print thank you
                        print("Thank you! The above information has been submitted. <br><br>");
                        $printform = false;

                        //mail notification to admin
                        /*$mailed = false;
                        $mailed = mail("admin@domain.edu", "Polisci Bi-Weekly Timesheet", "This is a notification that an account request has been made by $name ($osu).", "From: address@domain.edu");

                        // check if mail succeeded
                        if(!$mailed)
                        {
                                echo "<p>Mail notification failed, please contact admin@domain.edu and notify of account request.</p>";
                        }*/
                }
                else
                {
                        print("Connection failed, please try again later or contact the IT.<br><br>");
                }

            }//end botcheck

        }//end if isset request submission

        // ------- Print Request Form -----------------

        if($printform)
        {
                print("<div id=\"requestform\">");
                print("   <table>");
                print("     <tr><td class=\"alignrighttop\">Full Name:</td><td><input maxLength=\"40\" size=\"40\" name=\"name\" value=\"$savedname\" tabindex=\"1\"></td></tr>");
                print("     <tr><td class=\"alignrighttop\"><sup><a href=\"javascript:ShowContent('info_namedotn')\">?</a></sup>Login Name:</td><td><input maxLength=\"40\" size=\"40\" name=\"login\" value=\"$login\" tabindex=\"1\"></td></tr>");
                print("     <tr><td class=\"alignrighttop\">Desired Password:</td><td><input type=\"password\" maxLength=\"40\" size=\"40\" name=\"password\" tabindex=\"1\"></td></tr>");
                print("     <tr><td class=\"alignrighttop\"><sup><a href=\"javascript:ShowContent('info_employeenum')\">?</a></sup>Employee Number:</td><td><input maxLength=\"9\" size=\"9\" name=\"employeenum\" value=\"$empnum\" tabindex=\"1\"></td></tr>");
                print("     <tr><td class=\"alignrighttop\">Role:</td><td>");
                print("     &nbsp;&nbsp;&nbsp;<input type=\"radio\" name=\"role\" value=\"Employee\">Employee<br>");
                print("     &nbsp;&nbsp;&nbsp;<input type=\"radio\" name=\"role\" value=\"Supervisor\">Supervisor<br>");
                print("     &nbsp;&nbsp;&nbsp;<input type=\"radio\" name=\"role\" value=\"Administrator\">Administrative Staff</td></tr>");
                print("     <tr><td class=\"alignrighttop\">Password Reset?</td><td><input type=\"checkbox\" name=\"reset\"></td></tr>");
                print("     <tr><td class=\"alignrighttop\"><input type=\"text\" class=\"noscreen\" name=\"botcheck\"></td></tr>");
                print("	  </table><br><br>");
                print("<input type=\"submit\" value=\"Submit\" name=\"request\">");
                print("</div>");

                print("<div id=\"info_namedotn\">");
                print("<p>Your login (e.g. smith.1). This will be your timesheet login.</p>
                <a href=\"javascript:HideContent('info_namedotn')\">[hide]</a>");
                print("</div>");

                print("<div id=\"info_employeenum\">");
                print("<p>Your employee number is an eight or nine digit number (e.g. 200123456). 
                If you do not know it, please contact your HR person.</p>
                <a href=\"javascript:HideContent('info_employeenum')\">[hide]</a>");
                print("</div>");
        }
        ?>
        </form>

        <br><br>

        </div>
</div>
</body>
</html>

