<?php

/*
Copyright (c) 2004 Jason Lockhart

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.

Rewritten by Joshua Morris
Last Updated: 24 May 2012

*/

require_once "include/timesheetfunctions.php";
require_once "include/configuration.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet</title>
<!-- Version 3.5.0 -->
</head>

<body>
<!-- header container -->
<div id="container">
	<?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Bi-Weekly Timesheet</div></div>"); ?>

		<!-- form container -->
		<div id="content_container">
<?php

// ------ Require Authentication to Show Timesheet, Else Redirect to Login Page ------------------------------------
$isvalidlogin = false;
$db_username='user';
$login_store = 4; //set to invalid default

// get user id & password, cut to length for security
$user = @substr($_POST[$log_name],0,30);
$user_pass = @substr($_POST[$log_password],0,64);

// ------ TEST IF USER INFORMATION IS VALID -----------------------------------------------------------------------

$isvalidlogin = checkValidLogin($db_username, $user, $user_pass);

if(!$isvalidlogin)
//if login errors for any reason
{
	// login is not valid print redirect
	trigger_error("Nonvalid Login",E_USER_ERROR);
	
	// check if account locked
	if($login_store == 3)
	{
		print("<br>Too many failed login attempts, please verify your login credentials, wait 30 mintues and try again.<br><br>");
	}
}
else
//if login is valid
{
	

    // ------ If Login Valid, Continue on to Display Timesheet ----------------------------------------------------------

    //----------------------------------------------------------------
    // Calculate Pay Period Information
    //----------------------------------------------------------------
    $results = calcPayPeriodInfo ();
    $paydates = $results[0];
    $payperiods = $results[1];
    $paydate = $results[2];
    $periodnumber = $results[3];

    //----------------------------------------------------------------
    // Update or Insert if Save or Submit Pressed
    //----------------------------------------------------------------
    if(isset($_POST['calc']) || isset($_POST['subapprove']))
    {

            //------ Check that Pay Period is not already locked ------

            // clean Pay_ID for queries
            $payidlastclean = 0;
            if($_POST[$payidlast] != "")
            {
                    //if last pay period id is not empty string, then it has a number, clean this number and add it to query
                    $payidlastclean = mysql_real_escape_string($_POST[$payidlast]);
            }

            // determine if payperiod is locked for approval
            $query = sprintf("SELECT SubmitTimestamp FROM vwtimesheetbyuserbypaystart WHERE Pay_ID = %s",mysql_real_escape_string($payidlastclean));
            $result = mysql_query($query); // execute query to check if locked
            
            if(!$result)
            // if getting submit timestamp failed
            {
                    trigger_error("Timesheet save",E_USER_ERROR);
            }
            else
            // if query succeeded
            {
                    // get results
                    $row = mysql_fetch_assoc($result);

                    // store Timestamp value
                    $user_submitvalue = $row['SubmitTimestamp'];				
            }

            if(!is_null($user_submitvalue))
            //timesheet is already locked, do not call Update function
            {
                    trigger_error("Already submitted",E_USER_ERROR);
            }
            else
            {

                    //------ If not already locked, perform update/insert ------

                    // create action to submit to InsertUpdateSubmitTimesheet
                    $action = "save";

                    if(isset($_POST['subapprove']))
                    {
                            // if Submit For Approval was press, set to approve
                            $action = "submit";
                    }

                    //----- Clean Input Before Query ---------------------------------------------

                    // build procedural call with ACTION, and PAY_ID
                    $query = "SELECT InsertUpdateSubmitTimesheet('$action',";
                    $query = $query."$payidlastclean,";
                    
                    // clean user and add to query
                    $user = @substr($_POST[$log_name],0,30);
                    $query = $query.sprintf("'%s',", mysql_real_escape_string($user));

                    // name no longer than 45 characters
                    $_POST[$namebox] = @substr($_POST[$namebox],0,45);
                    // employeeid no longer than 9 characters
                    $_POST[$employeeid] = @substr($_POST[$employeeid],0,9);
                    // record no longer than 2 characters
                    $_POST[$record] = @substr($_POST[$record],0,2);

                    $query = $query.sprintf("'%s','%s','%s',", mysql_real_escape_string($_POST[$namebox]), mysql_real_escape_string($_POST[$employeeid]), mysql_real_escape_string($_POST[$record]));

                    // set pay period beginning date
                    if(! isset($_POST[$payperiod]))
                    {
                            $db_date = $paydate;			
                    }
                    else
                    {
                            // cut previously selected value to no longer than 8 characters
                            $db_date = substr($_POST[$payperiod],0,8);			
                    }

                    // clean and add to query
                    $query = $query.sprintf("'%s',", mysql_real_escape_string($db_date));

                    // rate no longer than 6 characters 
                    $_POST['rate'] = @substr($_POST['rate'],0,6);

                    // clean and add to query
                    $query = $query.sprintf("'%s',", mysql_real_escape_string($_POST['rate']));

                    // return only fixed length so that printing does not get too long
                    if(strlen($_POST[$commentbox]) > 450)
                    {
                            echo "<h2>Comment box too long. Truncated to allowed length. Click Save to clear this notification.</h2>";
                    }

                    // comment box no longer than 450 characters
                    $_POST[$commentbox] = @substr($_POST[$commentbox],0,450);

                    // clean and add to query
                    $query = $query.sprintf("'%s',", mysql_real_escape_string($_POST[$commentbox]));

                    // clean hour blocks and add to query
                    for($week=1; $week<=2; $week += 1)
                    {
                            for($day=1; $day<8; $day += 1)
                            {
                                    for($block=1; $block<=3; $block+=1)
                                    {
                                            $wkdyhin=$week.$day."hin".$block;
                                            $wkdymin=$week.$day."min".$block;
                                            $wkdyhout=$week.$day."hout".$block;
                                            $wkdymout=$week.$day."mout".$block;

                                            // cut lengths for security
                                            $_POST[$wkdyhin] = @substr($_POST[$wkdyhin],0,2);
                                            $_POST[$wkdymin] = @substr($_POST[$wkdymin],0,2);
                                            $_POST[$wkdyhout] = @substr($_POST[$wkdyhout],0,2);
                                            $_POST[$wkdymout] = @substr($_POST[$wkdymout],0,2);

                                            // clean against SQL injection
                                            $hin_clean = mysql_real_escape_string($_POST[$wkdyhin]);
                                            $min_clean = mysql_real_escape_string($_POST[$wkdymin]);
                                            $hout_clean = mysql_real_escape_string($_POST[$wkdyhout]);
                                            $mout_clean = mysql_real_escape_string($_POST[$wkdymout]);

                                            // for every block, add column to update query to modify database
                                            $query = $query."'$hin_clean',";
                                            $query = $query."'$min_clean',";
                                            $query = $query."'$hout_clean',";
                                            $query = $query."'$mout_clean',";

                                    }//endforblocks

                                    // track input boxes
                                    $wkdysick = $week.$day."sick";
                                    $wkdyvac = $week.$day."vac";
                                    $wkdycode = $week.$day."code";

                                    // cut lengths for security
                                    $_POST[$wkdysick] = @substr($_POST[$wkdysick],0,3);
                                    $_POST[$wkdyvac] = @substr($_POST[$wkdyvac],0,3);
                                    $_POST[$wkdycode] = @substr($_POST[$wkdycode],0,3);

                                    // clean against SQL injection
                                    $sick_clean = mysql_real_escape_string($_POST[$wkdysick]);
                                    $vac_clean = mysql_real_escape_string($_POST[$wkdyvac]);
                                    $code_clean = mysql_real_escape_string($_POST[$wkdycode]);

                                    $query = $query."'$sick_clean',";
                                    $query = $query."'$vac_clean',";

                                    // don't print last comma
                                    if($wkdycode == '27code')
                                    {
                                            $query = $query."'$code_clean'";
                                    }
                                    else
                                    {
                                            $query = $query."'$code_clean', ";
                                    }

                            }//endforday
                    }//endforweek

                    // add final closing piece
                    $query = $query.") as message";

                    // execute
                    $result = mysql_query($query);

                    // if query failed
                    if(!$result)
                    {
                            trigger_error("Timesheet save",E_USER_ERROR);
                    }
                    else
                    {
                            // get results
                            $row = mysql_fetch_assoc($result);

                            // store Pay_ID
                            $insertmessage = $row['message'];

                            //if action is submission and it succeeded, email notification to their supervisor
                            if($action == "submit" and $result)
                            {
                                    // get supervisor email
                                    $query = "SELECT Supervisor FROM vwuserinfo WHERE user = '$user'";
                                    // run query
                                    $result = mysql_query($query);

                                    if($result)
                                    {
                                            // get results
                                            $row = mysql_fetch_assoc($result);

                                            // store supervisor email
                                            $superusername = $row['Supervisor'];

                                            // notify
                                            emailNotify($user, $superusername, $systemfromaddress, $_POST[$namebox], $db_date, 1);							

                                    }
                                    else
                                    {
                                            trigger_error("Supervisor email",E_USER_ERROR);
                                    }
                            }

                    }
            }//endelse-timesheet not locked

    }//end if save or submit


    //----------------------------------------------------------------
    // Get the Selected Timesheet Info user
    //----------------------------------------------------------------

    // Pay_ID variable
    $payid = -1;  // set to -1 as autoinc field will always be >= 0

    // Name, ID, Record variables
    $name_store = "";
    $id_store = "";
    $record_store = "";

    // get Rate, Comments, Hours variables
    $rate_store = "7.00";
    $currentrate_store = "";
    $comment_store = "";
    $time_store = array();
    $sick_store = array();
    $vac_store = array();
    $code_store = array();

    // store TimesheetNumber, hours left
    $timesheetnumber_store = 0;
    $hrsleft_store = 9999; // default to non-work study value

    // get user id, cut down to known length for security, no more than 30 characters
    $user = @substr($_POST[$log_name],0,30);

    // get the pay start date to query on, cut down to known length for security, no more than 8 characters
    $date = $paydate;
    if(isset($_POST[$payperiod]))
    {
            $date = @substr($_POST[$payperiod],0,8);
    }

    // query the view for timesheet select based on login & paydate
    $query = sprintf("SELECT * FROM vwtimesheetbyuserbypaystart WHERE user='%s' AND paystart='%s'", mysql_real_escape_string($user), mysql_real_escape_string($date));

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {

            // get results
            $row = mysql_fetch_assoc($result);

            // store Pay_ID
            $payid = $row['Pay_ID'];

            // store Name, ID, Record to display
            $name_store = $row['name'];
            $id_store = $row['id'];
            $record_store = $row['record'];

            // store Rate display
            $rate_store = $row['rate'];
            $currentrate_store = $row['CurrentRate'];
            if(! isset($rate_store))
            {
                    $rate_store = $currentrate_store;
            }

            // store comments to display
            $comment_store = $row['commentbox'];

            // store status of user to display timesheet type
            $status = $row['status'];

            // store IsUser permission to check if user has permission to view this sheet
            $isuser = $row['IsUser'];

            // determine if payperiod is locked for approval
            $user_submitvalue = $row['SubmitTimestamp'];

            // determine if payperiod is approved
            $admin_approvevalue = $row['ApproveTimestamp'];

            // get TimesheetNumber
            $timesheetnumber_store = $row['TimesheetNumber'];

            // get # of work study hours left
            $hrsleft_store = $row['HrsLeft'];

            // if user_submitvalue is not null, then timestamp has a value, hence it has been submitted already
            if(!is_null($user_submitvalue))
            {
                    $user_submitted = "readOnly";
            }

            // store Hour blocks to display
            for($week=1; $week<=2; $week += 1)
            {
                    for($day=1; $day<8; $day += 1)
                    {
                            for($block=1; $block<=3; $block+=1)
                            {
                                    $wkdyhin=$week.$day."hin".$block;
                                    $wkdymin=$week.$day."min".$block;
                                    $wkdyhout=$week.$day."hout".$block;
                                    $wkdymout=$week.$day."mout".$block;

                                    // for every block, store info from database to set fields to
                                    $time_store[$wkdyhin] = $row[$wkdyhin];
                                    $time_store[$wkdymin] = $row[$wkdymin];
                                    $time_store[$wkdyhout] = $row[$wkdyhout];
                                    $time_store[$wkdymout] = $row[$wkdymout];
                            }

                            $wkdysick = $week.$day."sick";
                            $wkdyvac = $week.$day."vac";
                            $wkdycode = $week.$day."code";

                            // for every day, store info from database to set sick/vac/code fields
                            $sick_store[$wkdysick] = $row[$wkdysick];
                            $vac_store[$wkdyvac] = $row[$wkdyvac];
                            $code_store[$wkdycode] = $row[$wkdycode];

                    }//endforday
            }//endforweek
            //end store Hours
    }//endelse !result
				
//----- Check if User Account is Disabled ---------------------------------------------------------------

if($status == 'D')
{
	trigger_error("Account disabled",E_USER_ERROR);
}
elseif($isuser == 0)
{
	trigger_error("Account permission",E_USER_ERROR);
}
else
//account not disabled & user has permission to fill out a timesheet
{

// ------- Update Info / Logout button -----------------
	print("<br>\n
	<table width=\"100%\">
	<tr>
	<td align=\"left\">
		<form name=\"userinfo\" action=\"timesheetuserinfo.php\" method=\"POST\">
		<input type=\"submit\" name=\"update\" value=\"Update User Info\" class=\"noprint\">
		<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">
		<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">
		<input type=\"hidden\" name=\"encrypted\" value=\"\">
		</form>
	</td>
	<td align=\"right\">
		<a href=\"index.php\"><input type=\"button\" value=\"Logout\" name=\"logout\" class=\"noprint\" onClick=\"window.location='index.php'\"></a>
	</td>
	</tr></table>\n\n");
	

//----- Begin Printing Timesheet Form -------------------------------------------------------------------
	//<!-- begin printing form with Post -->
	print("<br><form name=\"timesheet\" action=\"timesheet.php\" method=\"POST\">\n\n");
	
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\"><input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\"><input type=\"hidden\" name=\"encrypted\" value=\"\">\n\n");
	

//----- Initialize Arrays ---------------------------------
	$weekdays = array(1 => "Sunday", 2 => "Monday", 3 => "Tuesday", 4 => "Wednesday", 5 => "Thursday", 6 => "Friday", 7 => "Saturday");
	
	// hours and minutes named by ## where first number is week and second number is day. Day 8 is the total.
	$totalhr = array(11 => 0, 12 => 0, 13 => 0, 14 => 0, 15 => 0, 16 => 0, 17 => 0, 18 => 0, 21 => 0, 22 => 0, 23 => 0, 24 => 0, 25 => 0, 26 => 0, 27 => 0, 28 => 0);
	$totalmin = array(11 => 0, 12 => 0, 13 => 0, 14 => 0, 15 => 0, 16 => 0, 17 => 0, 18 => 0, 21 => 0, 22 => 0, 23 => 0, 24 => 0, 25 => 0, 26 => 0, 27 => 0, 28 => 0);
	
	// array to hold info for input box error highlighting, elements should be "" unless changed to #FF000 by error code
	$inputstyle = array();
	
	// arrays to hold results of the calculateTimesheet function and read back into POST
	$calcresults = array();
	$calcforpost = array();

        // ------- Perform Timesheet Calculations -----------------
	$twowktotal = 0;
	
	$calcresults = calculateTimesheet($status, $time_store, $inputstyle, $totalhr, $totalmin, $sickhr, $vacationhr, $twowktotal, $sick_store, $vac_store, $code_store, $user_submitvalue, $hrsleft_store, $hrsperdaymax, $hrsperweekmax);
	
	// store returned values into appropriate variables
	$calcforpost = $calcresults[0];
	$inputstyle = $calcresults[1];
	$totalhr = $calcresults[2];
	$totalmin = $calcresults[3];
	$sickhr = $calcresults[4];
	$vacationhr = $calcresults[5];
	$twowktotal = $calcresults[6];
	
        // ------- Visual if Timesheet is locked from changes -----------------

	// check if approved
	if(!is_null($admin_approvevalue))
	{
		print("<p align=\"right\">CHANGES LOCKED<br>APPROVED<br>Timesheet Number: $timesheetnumber_store</p>");
	}
	// else check if submitted
	elseif(!is_null($user_submitvalue))
	{
		print("<p align=\"right\">CHANGES LOCKED<br>SUBMITTED FOR APPROVAL<br>Timesheet Number: $timesheetnumber_store</p>");
	}

        // ------- Warn if Limited Funded Employee Study Hours are getting low -----------------
	if($hrsleft_store < $hrswarninglevel) // change integer to be value warning should be displayed at
	{
		echo "<h2 class=\"nonprintwarning\">Number of remaining hours is low: $hrsleft_store</h2>";
	}
	
        // ------- Place Hidden Field to track last payid value -----------------

	print("<input type=\"hidden\" name=\"$payidlast\" value=\"$payid\">\n\n");
	
        // ------- Display Name, Employee ID, Record # Information -----------------
	
	// store post to give to print function below
	$userinfoforpost = array();
	$userinfoforpost[$namebox] = $name_store;
	$userinfoforpost[$employeeid] =  $id_store;
	$userinfoforpost[$record] = $record_store;
	
	displayNameIdRecord('lock', $namebox, $employeeid, $record, $userinfoforpost);
	
        // ------- Display Pay Period Information -----------------
	
	// pass POST value to selected_period
	$selected_period = $_POST[$payperiod];
	
	$paystart = displayPayPeriodDropDown($selected_period, $payperiod, $paydates, $payperiods, $maxpayperiod);
	
        // ------- Display Form -----------------

	displayTimesheet($status, $calcforpost, $paystart, $weekdays, $inputstyle, $user_submitted, $totalhr, $totalmin, $sickhr, $vacationhr);
		
	// print rate, hour, total row
	displayRateTotalHours($rate_store, $twowktotal, $user_submitted);
	
	
        // ------- Display Comments Box -----------------

	// print textarea for worker notes
	displayComments($comment_store, $user_submitted, $commentbox, $status);
	
	// convert to html (otherwise ',",\ characters will cause strange textbox behavior
	$commentshtml = htmlentities($comment_store);
	$_POST[$commentbox] = $commentshtml;


        //----- Print Submit buttons -----

	// disable save & approval buttons if already submitted
	$disablebutton = "";
	if(!is_null($user_submitvalue))
	{
		$disablebutton = "disabled";
	}
	
	print("<p class=\"noprint\">Click \"Save\" below to calculate hours and to save hours and comments
	for printing or later changes. <b>Be sure to click \"Save\" before printing or leaving the page</b>. Click \"Change\" to change pay periods without overwriting with the current values. Click \"Submit for Approval\" to turn in the timesheet electronically. The Work Study Hours remaining, if displayed, may be out of date if not recent and should serve as a general guideline only. It is the employee's responsibility to track work study hours and work no more than the hours remaining.</p>
	<input type=\"submit\" value=\"Save\" name=\"calc\" class=\"noprint\" $disablebutton>
	<input type=\"button\" value=\"Print\" name=\"print\" class=\"noprint\" onClick=\"DoPrint();\">
	<input type=\"submit\" value=\"Submit for Approval\" name=\"subapprove\" class=\"noprint\" $disablebutton>
	<script type=\"text/javascript\" language=\"JavaScript\"><!--
		function DoPrint()
		{
			// document.timesheet.submit();
			window.print();
		}
	//--> </script>
	</form>
			<!-- print signature lines at the bottom -->
			<br>
			<table>
			  <tr>
			    <td class=\"signature\">___________________________________ </td><td class=\"signature\">___________________________________ </td>
			  </tr>
			  <tr>
			    <td class=\"signature\">Employee Signature / Date</td><td class=\"signature\">Supervisor Signature / Date</td>
			  </tr>
			</table>
			<br><br>
			<!-- display usage notes -->
			<p class=\"noprint\">Notes: <i>Both 12 or 24 hour time can be used.  It will compensate for a rollover from am->pm.
			24 hour time must be used for shifts lasting more than 12 hours in a day (as long as there is no midnight rollover
			).  Rolling over midnight in 24 hour time will break it.  In 12 hour time midnight rollover is accepted. Starting
			and ending hour must be filled in otherwise time block is ignored. Timesheet is designed to be printed from the browser.
			<br><br> </i></p>");
    }//end account not disabled
}//end require auth else
?>

		</div>
	</div>
</body>
</html>

