<?php

/*
Copyright (c) 2012 Joshua Morris
Last Updated: 24 May 2012

*/

require_once "include/timesheetfunctions.php";
require_once "include/configuration.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet | Hours Entry</title>
<!-- Version 3.5.0 -->
</head>

<body>
<!-- header container -->
<div id="container">
	<?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Administrative Limited Funds Entry</div></div>"); ?>
		<!-- form container -->
		<div id="content_container">
<?php

// ------ Require Authentication to Show Timesheet, Else Redirect to Login Page ------------------------------------
$log_name = "t514ne";
$log_password = "t234pe";
$isvalidlogin = false;
$db_username='staff';

// get user id & password, cut to length for security
$user = @substr($_POST[$log_name],0,30);
$user_pass = @substr($_POST[$log_password],0,64);

// ------ TEST IF USER INFORMATION IS VALID -----------------------------------------------------------------------

$isvalidlogin = checkValidLogin($db_username, $user, $user_pass);

if(!$isvalidlogin)
{
	// login is not valid print redirect
	trigger_error("Nonvalid Login",E_USER_ERROR);
	
	// check if account locked
	if($login_store == 3)
	{
		print("<br>Too many failed login attempts, please verify your login credentials, wait 30 mintues and try again.<br><br>");
	}	
}
else
{
    // ------ If Login Valid, Continue on to Display Timesheet ----------------------------------------------------------

    //----------------------------------------------------------------
    // Calculate Pay Period Information
    //----------------------------------------------------------------
    $results = calcPayPeriodInfo ();
    $paydates = $results[0];
    $payperiods = $results[1];
    $paydate = $results[2];
    $periodnumber = $results[3];
    
    //----------------------------------------------------------------
    // Check if Update Hours pressed
    //----------------------------------------------------------------

    if(isset($_POST['updatehrs']))
    {

            // read in submitted hours
            $count = $_POST['count'];
            $queryfailed = 0;
            while($count > 0)
            {
                    // since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
                    $count = $count - 1;

                    // build field names
                    $hrscount = 'hrs'.$count;
                    $hrsoldcount = 'hrsold'.$count;
                    $namecount = 'name'.$count;

                    // cut variables for security
                    $hrs_cut = @substr($_POST[$hrscount],0,7);  // new hrs submitted
                    $user_cut = @substr($_POST[$namecount],0,30); // username stored in POST
                    $hrsold_cut = @substr($_POST[$hrsoldcount],0,7); // old hrs store in POST

                    //---
                    // find user's pay rate to convert dollar amount into hrs left

                    // query the view for rate information
                    $query = sprintf("SELECT rate FROM vwusersactive WHERE user='$user_cut'");

                    // execute
                    $result = mysql_query($query);

                    // if query failed
                    if(!$result)
                    {
                            trigger_error("No connection",E_USER_ERROR);
                    }
                    else
                    {
                            // get data (rate)
                            $row = mysql_fetch_assoc($result);
                            $rate_store = $row['rate'];
                    }
                    //---

                    // calculate new hours
                    $newhrs = round($hrs_cut / $rate_store,2);

                    // only update if new value
                    if(!empty($_POST[$hrscount]))
                    {

                            // check if hours are negative, if so set to amount that means non-work study
                            if($newhrs < 0)
                            {
                                    $newhrs = 9999;
                            }

                            // update query
                            $query = sprintf("SELECT UpdateHrsEntry ('%s','%s')", mysql_real_escape_string($newhrs), mysql_real_escape_string($user_cut));

                            // execute
                            $result = mysql_query($query);

                            // if query failed
                            if(!$result)
                            {
                                    $queryfailed = 1;
                            }

                    }//end if newhrs != oldhrs

            }//end while

            // check if any queries failed
            if($queryfailed == 1)
            {			
                    trigger_error("Hours update",E_USER_ERROR);
            }
    }//endif updatehrs

    //----------------------------------------------------------------
    // list all active employees
    //----------------------------------------------------------------

    // variables to store
    $payid_store = array();  // hold payids
    $employeename_store = array(); // hold employee names
    $employeeuser_store = array(); // hold employee user names

    // get user id, cut down to known length for security, no more than 30 characters
    $user = @substr($_POST[$log_name],0,30);

    // query the view for timesheet select based on login & paydate
    $query = sprintf("SELECT * FROM vwusersactive");

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {
            $count = 0;
            // get results
            while($row = mysql_fetch_assoc($result))
            {
                    // get employee's name
                    $employeename_store[$count] = $row['name'];

                    // get supervisor user name
                    $supervisoruser_store[$count] = $row['Supervisor'];

                    // get employee user name
                    $employeeuser_store[$count] = $row['user'];

                    // get work study hours left
                    $hrs_store[$count] = $row['HrsLeft'];

                    // get work study hrs update timestamp
                    $hrsupdated_store[$count] = $row['HrsLastUpdate'];

                    // get the current rate
                    $rate_store[$count] = $row['rate'];

                    $count = $count + 1;
            }

    }//endelse !result


    //----------------------------------------------------------------
    // Check if logged in user has Staff permission
    //----------------------------------------------------------------

    $permission = checkValidPermissions($user, 'staff');
    
    if($permission)
    //account not disabled & user has permission 
    {

        // ------- Display Return to Summary Button -----------------

	//<!-- return to summary page form -->
	print("<br><form name=\"returntosummary\" action=\"timesheetstaffsummary.php\" method=\"POST\" >");
	
	// pass login name & password to remain logged in
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	
	// pass payperiod selected
	print("<input type=\"hidden\" name=\"$payperiod\" value=\"$paydate\">");
	
	// add back to summary button
	print("<input type=\"submit\" name=\"backtosummary\" value=\"Back to Summary\" class=\"noprint\">");
	print("</form>\n");

        // ------- Begin Hours Form -----------------

	//<!-- review timesheet form with Post -->
	print("<br><form name=\"hrsentry\" action=\"timesheetstaffhrsentry.php\" method=\"POST\" >");
	
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	print("<input type=\"hidden\" name=\"count\" value=\"$count\">");

        // ------- Display Student List -----------------

	// print beginning of table & header row
	print(" <!-- Students -->		
		<center>
		<table id=\"summary\">
		<tr>
		  <th></th><th>Name</th><th>New Amount</th><th>&nbsp;&nbsp;Hrs Left</th><th>&nbsp;&nbsp;Hrs Updated</th><th></th>
		</tr>");
	
	// print employees and the status of the timesheets for the pay period
	// cycle back through in same order so alphabetical by last name.
	$count2 = 0;
	while($count2 < $count)
	{
		
		// convert date to more readable text, if hrs left = 9999 then non-work study student
		$updatetime = "";
		$hrstime;
		if($hrs_store[$count2] != 9999)
		{
			// then work study student
			$updatetime = date("m/d/Y", strtotime($hrsupdated_store[$count2]));
			$hrstime = $hrs_store[$count2];
		}
		else
		{
			// then non-work study student, set hours to NA
			$hrstime = "NA";
		}
		
                $emailaddressemployee = getUserEmail($employeeuser_store[$count2]);
                $emailaddresssuper = getUserEmail($supervisoruser_store[$count2]);
		
		print("	
		<tr>
		  <!-- add email button with unique names and mouse rollover effect -->
		  <td>
		  	<a href=\"mailto:$emailaddressemployee\" onMouseover=\"document.employeeemail$count2.src='email_buttongrayover.gif'\" onMouseout=\"document.employeeemail$count2.src='email_buttongray.gif'\">
			<img src=\"email_buttongray.gif\" name=\"employeeemail$count2\" class=\"styleimage\" alt=\"emailicon\"></a></td>
		  <!-- add employee name as a stylized input button linked to the timesheet to review it -->
		  <td>
		      	$employeename_store[$count2]
		  </td>
		  <!-- add input for new amount entry -->
		  <td>
		  	<input name=\"hrs$count2\" value=\"\" size=\"7\" maxlength=\"7\">
			<input type=\"hidden\" name=\"name$count2\" value=\"$employeeuser_store[$count2]\">
			<input type=\"hidden\" name=\"hrsold$count2\" value=\"$hrs_store[$count2]\">
		  </td>		  
		  <!-- add remaining work study hrs left -->
		  <td>
		    	$hrstime
		  </td>
		  <!-- show when hrs last updated -->
		  <td>
		  	$updatetime
		  </td>
		  <!-- add mail link for supervisor -->
		  <td>
		  	<a href=\"mailto:$emailaddresssuper\" onMouseover=\"document.superemail$count2.src='email_iconwhite_smover.gif'\" onMouseout=\"document.superemail$count2.src='email_iconwhite_sm.gif'\"><img src=\"email_iconwhite_sm.gif\" name=\"superemail$count2\" class=\"styleimage\" alt=\"emailicon\"></a>
		  </td>
		</tr>
		");
		
		// since array is zero indexed (i.e. count = 1 then one value stored at employeename_store[0]
		$count2 = $count2 + 1;
	}
	
	// print end of table
	print("	</table><br>");
		
	// print Submit button
	print("<input type=\"submit\" value=\"Update Hours\" name=\"updatehrs\"></center>");
	
	// print end of form
	print("</form>");
	
	// print usage notes
	// ------- Print Usage Notes -----------------
	print("<div id=\"notes\">
	<!-- display usage notes -->
	<p>Fill in the remaining amount of funds left for the employee. To submit changes press \"Update Hours\". The amount of funds 
        will be automatically calculated into the number of hours remaining based on the pay rate for the employee. Please ensure that 
        the pay rates are correct before entering new amounts. A negative value signifies that the employee is not a limited funds employee. 
        To set an employee to unlimited, set \"New Amount\" to be \"-1\".</p>
	
	<p>\"Hrs Left\" represents the number of funded hours remaining as of the last update, given in the \"Hrs Updated\" column. This 
        number may be out of date if not recent and should serve as a general guideline only.</p>
        
        <p>Warnings for limited funding employees are displayed on the employee timesheet, the supervisor review page, and the administrative
        staff review page.</p></div>");
	
	// print symbol legend
	
	print("<div id=\"legend\"> 
	<table>
	<tr><td><img src=\"email_buttongray.gif\" alt=\"email\"></td><td>click to email the employee.</td></tr> 
	<tr><td><img src=\"email_iconwhite_sm.gif\" alt=\"email\"></td><td>click to to email the supervisor.</td></tr>
	</table>
	</div>");
	
	// print footer
	print("<div id=\"footer\"><br><br></div>");
	
    }//end account permission
}//end require auth else
?>

		</div>
	</div>
</body>
</html>

