<?php

/*
Copyright (c) 2012 Joshua Morris
Last Updated: 24 May 2012


*/

require_once "include/timesheetfunctions.php";
require_once "include/configuration.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet | Change Pay Rate</title>
<!-- Version 3.5.0 -->
</head>

<body>
<!-- header container -->
<div id="container">
	<?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Administrative Pay Rate Entry</div></div>"); ?>
		<!-- form container -->
		<div id="content_container">
<?php

// ------ Require Authentication to Show Timesheet, Else Redirect to Login Page ------------------------------------
$log_name = "t514ne";
$log_password = "t234pe";
$isvalidlogin = false;
$db_username='staff';

// get user id & password, cut to length for security
$user = @substr($_POST[$log_name],0,30);
$user_pass = @substr($_POST[$log_password],0,64);

// ------ TEST IF USER INFORMATION IS VALID -----------------------------------------------------------------------

$isvalidlogin = checkValidLogin($db_username, $user, $user_pass);

if(!$isvalidlogin)
{
	// login is not valid print redirect
	trigger_error("Nonvalid Login",E_USER_ERROR);
	
	// check if account locked
	if($login_store == 3)
	{
		print("<br>Too many failed login attempts, please verify your login credentials, wait 30 mintues and try again.<br><br>");
	}	
	
}
else
// ------ If Login Valid, Continue on to Display Timesheet -----------------
{
    //----------------------------------------------------------------
    // Calculate Pay Period Information
    //----------------------------------------------------------------
    $results = calcPayPeriodInfo ();
    $paydates = $results[0];
    $payperiods = $results[1];
    $paydate = $results[2];
    $periodnumber = $results[3];
    
    //----------------------------------------------------------------
    // Check if Update Hours pressed
    //----------------------------------------------------------------

    if(isset($_POST['updaterate']))
    {

            // read in submitted hours
            $count = $_POST['count'];
            $queryfailed = 0;
            while($count > 0)
            {
                    // since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
                    $count = $count - 1;

                    // build field names
                    $ratecount = 'rate'.$count;
                    $rateoldcount = 'rateold'.$count;
                    $namecount = 'name'.$count;

                    // cut variables for security
                    $rate_cut = @substr($_POST[$ratecount],0,7);  // new rate submitted
                    $user_cut = @substr($_POST[$namecount],0,30); // username stored in POST
                    $rateold_cut = @substr($_POST[$rateoldcount],0,7); // old rate store in POST

                    // only update if new value
                    if($rate_cut != $rateold_cut)
                    {
                        $rate_cut = floatval($rate_cut); // convert to float
                        $rate_cut = round($rate_cut,2); // round to two decimal places

                        //reject all non-numeric entries
                        if($rate_cut > 0)
                        {
                            // form update query
                            $query = sprintf("SELECT UpdateRateEntry ('%s','%s')", mysql_real_escape_string($rate_cut), mysql_real_escape_string($user_cut));

                            // execute
                            $result = mysql_query($query);

                            // if query failed
                            if(!$result)
                            {
                                    $queryfailed = 1;
                            }
                        } else {
                            trigger_error("Invalid payrate",E_USER_ERROR);
                        }//endelse is numeric
                    }//end if newrate != oldrate

            }

            // check if any queries failed
            if($queryfailed == 1)
            {			
                    trigger_error("No connection",E_USER_ERROR);
            }

    }

    //----------------------------------------------------------------
    // Get the Selected List of Students for user
    //----------------------------------------------------------------

    // variables to store
    $payid_store = array();  // hold payids
    $employeename_store = array(); // hold employee names
    $employeeuser_store = array(); // hold employee user names

    // get user id, cut down to known length for security, no more than 30 characters
    $user = @substr($_POST[$log_name],0,30);

    // query the view for timesheet select based on login & paydate
    $query = sprintf("SELECT * FROM vwusersactive");

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {
            $count = 0;
            // get results
            while($row = mysql_fetch_assoc($result))
            {
                    // get employee's name
                    $employeename_store[$count] = $row['name'];

                    // get supervisor user name
                    $supervisoruser_store[$count] = $row['Supervisor'];

                    // get employee user name
                    $employeeuser_store[$count] = $row['user'];

                    // get work study hours left
                    $currentrate_store[$count] = $row['rate'];

                    $count++;
            }

    }//endelse !result


    //----------------------------------------------------------------
    // Check if logged in user has Staff permission
    //----------------------------------------------------------------

    $permission = checkValidPermissions($user, 'staff');
    
    if($permission)
    //account not disabled & user has permission 
    {

    // ------- Display Return to Summary Button -----------------

	//<!-- return to summary page form -->
	print("<br><form name=\"returntosummary\" action=\"timesheetstaffsummary.php\" method=\"POST\" >");
	
	// pass login name & password to remain logged in
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	
	// pass payperiod selected
	print("<input type=\"hidden\" name=\"$payperiod\" value=\"$paydate\">");
	
	// add back to summary button
	print("<input type=\"submit\" name=\"backtosummary\" value=\"Back to Summary\" class=\"noprint\">");
	print("</form>\n");

        // ------- Begin Hours Form -----------------

	//<!-- review timesheet form with Post -->
	print("<br><form name=\"rateentry\" action=\"timesheetstaffrateentry.php\" method=\"POST\" >");
	
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	print("<input type=\"hidden\" name=\"count\" value=\"$count\">");

        // ------- Display Student List -----------------

	// print beginning of table & header row
	print(" <!-- Students -->		
		<center>
		<table id=\"summary\">
		<tr>
		  <th></th><th>Name</th><th>Pay Rate (&#36;)</th><th>&nbsp;&nbsp;</th>
		</tr>");
	
	// print employees and the status of the timesheets for the pay period
	// cycle back through in same order so alphabetical by last name.
	$count2 = 0;
	while($count2 < $count)
	{
            $emailaddressemployee = getUserEmail($employeeuser_store[$count2]);

            print("	
            <tr>
                <!-- add email button with unique names and mouse rollover effect -->
                <td>
                    <a href=\"mailto:$emailaddressemployee\" onMouseover=\"document.employeeemail$count2.src='email_buttongrayover.gif'\" onMouseout=\"document.employeeemail$count2.src='email_buttongray.gif'\">
                    <img src=\"email_buttongray.gif\" name=\"employeeemail$count2\" class=\"styleimage\" alt=\"emailicon\"></a></td>
                <!-- add employee name as a stylized input button linked to the timesheet to review it -->
                <td>
                    $employeename_store[$count2]
                </td>
                <!-- add input for new rate entry -->
                <td>
                    <input name=\"rate$count2\" value=\"$currentrate_store[$count2]\" size=\"7\" maxlength=\"7\">
                    <input type=\"hidden\" name=\"name$count2\" value=\"$employeeuser_store[$count2]\">
                </td>		  
                <!-- add mail link for supervisor -->
                <td>
                    <a href=\"mailto:$supervisoruser_store[$count2]@domain.edu\" onMouseover=\"document.superemail$count2.src='email_iconwhite_smover.gif'\" onMouseout=\"document.superemail$count2.src='email_iconwhite_sm.gif'\"><img src=\"email_iconwhite_sm.gif\" name=\"superemail$count2\" class=\"styleimage\" alt=\"emailicon\"></a>
                </td>
            </tr>
            ");

            // since array is zero indexed (i.e. count = 1 then one value stored at employeename_store[0]
            $count2++;
	}
	
	// print end of table
	print("	</table><br>");
		
	// print Submit button
	print("<input type=\"submit\" value=\"Update Pay Rate\" name=\"updaterate\"></center>");
	
	// print end of form
	print("</form>");
	
	// print usage notes
	// ------- Print Usage Notes -----------------
	print("<div id=\"notes\">
	<!-- display usage notes -->
	<p>Fill in the new hourly pay rate for employees of your choice. Values entered are converted to float and rounded to two decimal places. To submit changes press \"Update Pay Rate\".</p>
	</div>\n");
	
	// print symbol legend
	
	print("<div id=\"legend\"> 
	<table>
	<tr><td><img src=\"email_buttongray.gif\" alt=\"email\"></td><td>click to email the employee.</td></tr> 
	<tr><td><img src=\"email_iconwhite_sm.gif\" alt=\"email\"></td><td>click to to email the supervisor.</td></tr>
	</table>
	</div>");
	
	// print list
	
	/*print("<div id=\"list\">
	<p><b></b><br><br>");
	
	// print end of list 
	print("</p>
	</div>");*/
	
	// print footer
	print("<div id=\"footer\"><br><br></div>");
	
    }//end account permission
}//end require auth else
?>

		</div>
	</div>
</body>
</html>

