<?php

/*
Copyright (c) 2004 Jason Lockhart

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.

Edited by Joshua Morris
Last Updated: 24 May 2012

*/

require_once "include/timesheetfunctions.php";
require_once "include/configuration.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet | Staff Review</title>
<!-- Version 3.5.0 -->
</head>

<body>
<!-- header container -->
<div id="container">
	<?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Administrative Timesheet Review</div></div>"); ?>
		<!-- form container -->
		<div id="content_container">
<?php

// ------ Require Authentication to Show Timesheet, Else Redirect to Login Page ------------------------------------
$log_name = "t514ne";
$log_password = "t234pe";
$isvalidlogin = false;
$db_username='staff';

// get user id & password, cut to length for security
$user = @substr($_POST[$log_name],0,30);
$user_pass = @substr($_POST[$log_password],0,64);

// ------ TEST IF USER INFORMATION IS VALID -----------------------------------------------------------------------

$isvalidlogin = checkValidLogin($db_username, $user, $user_pass);

if(!$isvalidlogin)
{
	// login is not valid print redirect
	trigger_error("Nonvalid Login",E_USER_ERROR);
	
	// check if account locked
	if($login_store == 3)
	{
		print("<br>Too many failed login attempts, please verify your login credentials, wait 30 mintues and try again.<br><br>");
	}	
}
else
// ------ If Login Valid, Continue on to Display Timesheet -----------------------------
{
    //----------------------------------------------------------------
    // Calculate Pay Period Information
    //----------------------------------------------------------------
    $results = calcPayPeriodInfo ();
    $paydates = $results[0];
    $payperiods = $results[1];
    $paydate = $results[2];
    $periodnumber = $results[3];
		
    //----------------------------------------------------------------
    // Deny if Button Pressed, Enter if Button Pressed
    //----------------------------------------------------------------
    if(isset($_POST['deny']) || isset($_POST['enter']))
    {

            //------ Check that Pay Period is not already locked ------

            // clean Pay_ID for queries
            if($_POST[$payidlast] != "")
            {
                    //if last pay period id is not empty string, then it has a number, clean this number and add it to query
                    $payidlastclean = mysql_real_escape_string($_POST[$payidlast]);
            }

            // determine if submitted for approval
            $query = "SELECT SubmitTimestamp, ApproveTimestamp, EnteredTimestamp FROM vwtimesheetbyuserbypaystart WHERE Pay_ID = $payidlastclean";

            // execute query to check if locked
            $result = mysql_query($query);

            // if query failed
            if(!$result)
            {
                    trigger_error("No connection",E_USER_ERROR);
            }
            else
            {
                    // get results
                    $row = mysql_fetch_assoc($result);

                    // store Timestamp values
                    $user_submitvalue = $row['SubmitTimestamp'];

                    $admin_submitvalue = $row['ApproveTimestamp'];

                    $admin_enteredvalue = $row['EnteredTimestamp'];
            }

            if(is_null($user_submitvalue))
            //timesheet not submitted or approved yet, do not call Deny function
            {
                    trigger_error("Not submitted",E_USER_ERROR);
            }
            elseif(is_null($admin_submitvalue))
            {
                    trigger_error("Not approved",E_USER_ERROR);
            }
            else
            //------ If already submitted, perform approve/deny ------
            {
                // if Deny
                if(isset($_POST['deny']))
                {
                        // build function call with PAY_ID
                        $query = sprintf("SELECT DenyTimesheet($payidlastclean,'Administrator','%s')",mysql_real_escape_string($user));

                        // execute
                        $result = mysql_query($query);

                        // if query failed
                        if(!$result)
                        {
                                trigger_error("Deny fail",E_USER_ERROR);
                        }else{
                                // notify employee that timesheet was denied
                                $sendemailnotification = 1;
                        }
                }
                elseif(isset($_POST['enter']))
                {
                        // build function call with PAY_ID
                        $query = sprintf("SELECT ApproveTimesheet($payidlastclean,'Administrator','%s')",mysql_real_escape_string($user));

                        // execute
                        $result = mysql_query($query);

                        // if query failed
                        if(!$result)
                        {
                                trigger_error("Approve fail",E_USER_ERROR);
                        }
                }//endif Post[enter]
        }//endelse-timesheet submitted
    }//endif deny

    //----------------------------------------------------------------
    // Get the Selected Timesheet Info for user
    //----------------------------------------------------------------
    // Pay_ID variable
    $payid = -1;  // set to -1 as autoinc field will always be >= 0

    // if first visit to page, display timesheet selected from previous form on timesheetsupersummary
    if(isset($_POST['count']))
    {
        $count = $_POST['count'];
    }else{
        $count = 0;
    }

    while($count > 0)
    {
            // since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at POST[payidstore0]
            $count = $count - 1;

            // build string "review#"
            $reviewnum = $review.$count;

            // see if this submit button was pressed
            if(isset($_POST[$reviewnum]))
            {
                    // if so then get the stored pay period id for this user/pay period

                    // build string "payidstore#"
                    $temp = $payidstore.$count;

                    // set payid to the value from the last form
                    $payid = $_POST[$temp];
            }
    }

    // if not first visit to the page, get the last pay id saved to POST
    if(isset($_POST[$payidlast]))
    {
            // if form previously submitted, set payid to the payid value cleaned above
            $payid = $_POST[$payidlast];			
    }

    // Name, ID, Record variables
    $name_store = "";
    $id_store = "";
    $record_store = "";

    // get Rate, Comments, Hours variables
    $rate_store = "7.00";
    $comment_store = "";
    $time_store = array();
    $sick_store = array();
    $vac_store = array();
    $code_store = array();

    // get Timesheet Number
    $timesheetnumber_store = 0;

    // get user id, cut down to known length for security, no more than 30 characters
    $user = @substr($_POST[$log_name],0,30);

    // get the pay start date to query on, cut down to known length for security, no more than 8 characters
    //set date to fetched paydate
    $date = $paydate;
    if(isset($_POST[$payperiod]))
    {
            // if a date was already selected, trim for security
            $date = @substr($_POST[$payperiod],0,8);
    }

    $query = "";

    // if change was pressed show new pay period, otherwise show last
    if(isset($_POST['change']))
    {
            // query the view for timesheet select based on login & paydate
            $query = sprintf("SELECT * FROM vwtimesheetbyuserbypaystart WHERE user='%s' AND paystart='%s'", mysql_real_escape_string($_POST[$employeeusernamelast]), mysql_real_escape_string($date));
    }
    else
    {
            // query the view for the timesheet select based on payperiodlast
            $query = sprintf("SELECT * FROM vwtimesheetbyuserbypaystart WHERE Pay_ID='%s'", mysql_real_escape_string($payid));
    }

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {

            // get results
            $row = mysql_fetch_assoc($result);

            // store Pay_ID
            $payid = $row['Pay_ID'];

            // store paystart if POST is not set
            $paydate = $row['paystart'];

            // store employee username
            $student = $row['user'];

            // store Name, ID, Record to display
            $name_store = $row['name'];
            $id_store = $row['id'];
            $record_store = $row['record'];

            // store Rate display
            $rate_store = $row['rate'];
            $currentrate_store = $row['CurrentRate'];
            if(! isset($rate_store))
            {
                    $rate_store = $currentrate_store;
            }

            // store comments to display
            $comment_store = $row['commentbox'];

            // store status of user to display timesheet type
            $status = $row['status'];

            // determine if payperiod is submitted for approval
            $user_submitvalue = $row['SubmitTimestamp'];

            // if user_submitvalue is not null, then timestamp has a value, hence it has been submitted already
            if(!is_null($user_submitvalue))
            {
                    $user_submitted = "readOnly";
            }

            // determine if payperiod approved
            $super_approvevalue = $row['ApproveTimestamp'];

            $super_username = $row['Supervisor'];

            // store timesheet number
            $timesheetnumber_store = $row['TimesheetNumber'];

            // determine if entered by staff already
            $admin_enteredvalue = $row['EnteredTimestamp'];

            // get # of work study hours left
            $hrsleft_store = $row['HrsLeft'];

            // get which supervisor approved it
            $approvedby = $row['ApprovedBy'];

            // store Hour blocks to display
            for($week=1; $week<=2; $week += 1)
            {
                    for($day=1; $day<8; $day += 1)
                    {
                            for($block=1; $block<=3; $block+=1)
                            {
                                    $wkdyhin=$week.$day."hin".$block;
                                    $wkdymin=$week.$day."min".$block;
                                    $wkdyhout=$week.$day."hout".$block;
                                    $wkdymout=$week.$day."mout".$block;

                                    // for every block, store info from database to set fields to
                                    $time_store[$wkdyhin] = $row[$wkdyhin];
                                    $time_store[$wkdymin] = $row[$wkdymin];
                                    $time_store[$wkdyhout] = $row[$wkdyhout];
                                    $time_store[$wkdymout] = $row[$wkdymout];
                            }

                            $wkdysick = $week.$day."sick";
                            $wkdyvac = $week.$day."vac";
                            $wkdycode = $week.$day."code";

                            // for every day, store info from database to set sick/vac/code fields
                            $sick_store[$wkdysick] = $row[$wkdysick];
                            $vac_store[$wkdyvac] = $row[$wkdyvac];
                            $code_store[$wkdycode] = $row[$wkdycode];

                    }//endforday
            }//endforweek
            //end store Hours
    }//endelse !result

    //----------------------------------------------------------------
    // Email notification
    //----------------------------------------------------------------

    // send email notification of timesheet denial if necessary
    if($sendemailnotification == 1)
    {
        emailNotify($user, $student, $systemfromaddress, $staff_name, $_POST[$payperiod], 3);
    }
    //----------------------------------------------------------------
    // Check if logged in user has Administrative Staff permission
    //----------------------------------------------------------------

    $permission = checkValidPermissions($user, 'staff');
    
    if($permission)
    //account not disabled & user has permission
    {

	// ------- Display Return to Summary Button -----------------

	//<!-- return to summary page form -->
	print("<br><form name=\"returntosummary\" action=\"timesheetstaffsummary.php\" method=\"POST\" >");
	
	// pass login name & password to remain logged in
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	
	// pass payperiod selected
	print("<input type=\"hidden\" name=\"$payperiod\" value=\"$paydate\">");
	
	// add back to summary button
	print("<input type=\"submit\" name=\"backtosummary\" value=\"Back to Summary\" class=\"noprint\">");
	print("</form>\n");

	//<!-- review timesheet form with Post -->
	print("<br><form name=\"timesheet\" action=\"timesheetstaffreview.php\" method=\"POST\" >");
	
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");

        //----- Initialize Arrays ---------------------------------
	$weekdays = array(1 => "Sunday", 2 => "Monday", 3 => "Tuesday", 4 => "Wednesday", 5 => "Thursday", 6 => "Friday", 7 => "Saturday");
	
	// hours and minutes named by ## where first number is week and second number is day. Day 8 is the total.
	$totalhr = array(11 => 0, 12 => 0, 13 => 0, 14 => 0, 15 => 0, 16 => 0, 17 => 0, 18 => 0, 21 => 0, 22 => 0, 23 => 0, 24 => 0, 25 => 0, 26 => 0, 27 => 0, 28 => 0);
	$totalmin = array(11 => 0, 12 => 0, 13 => 0, 14 => 0, 15 => 0, 16 => 0, 17 => 0, 18 => 0, 21 => 0, 22 => 0, 23 => 0, 24 => 0, 25 => 0, 26 => 0, 27 => 0, 28 => 0);
	
	// array to hold info for input box error highlighting, elements should be "" unless changed to #FF000 by error code
	$inputstyle = array();
	
	// arrays to hold results of the calculateTimesheet function and read back into POST
	$calcresults = array();
	$calcforpost = array();	

        // ------- Perform Timesheet Calculations -----------------
	
	// supervisors cannot modify hours so lock display always
	$lockfields = "readOnly";
	
	// initialize two week total
	$twowktotal = 0;
	
	$calcresults = calculateTimesheet($status, $time_store, $inputstyle, $totalhr, $totalmin, $sickhr, $vacationhr, $twowktotal, $sick_store, $vac_store, $code_store, $lockfields, $hrsleft_store, $hrsperdaymax, $hrsperweekmax);
	
	// store returned values into appropriate variables
	$calcforpost = $calcresults[0];
	$inputstyle = $calcresults[1];
	$totalhr = $calcresults[2];
	$totalmin = $calcresults[3];
	$sickhr = $calcresults[4];
	$vacationhr = $calcresults[5];
	$twowktotal = $calcresults[6];

        // ------- Visual if Timesheet is already Submitted, Approved, or Entered -----------------
	
	if(!is_null($admin_enteredvalue))
	{
		print("<p align=\"right\">ENTERED<br>Timesheet Number: $timesheetnumber_store</p>");
	}
	elseif(!is_null($super_approvevalue))
	{
		print("<p align=\"right\">APPROVED<br>Timesheet Number: $timesheetnumber_store</p>");
	}
	elseif(!is_null($user_submitvalue))
	{
		print("<p align=\"right\">SUBMITTED FOR APPROVAL<br>Timesheet Number: $timesheetnumber_store</p>");
	}
	
        // ------- Warn if Limited Funds Hours are getting low -----------------
	if($hrsleft_store < $hrswarninglevel) // change integer to be value warning should be displayed at
	{
		echo "<h2 class=\"nonprintwarning\">Number of remaining hours is low: $hrsleft_store</h2>";
	}
	
        // ------- Place Hidden Field to track last payid value -----------------

	print("<input type=\"hidden\" name=\"$payidlast\" value=\"$payid\">");
	
        // ------- Place Hidden Field to track last employee userid value -----------------

	print("<input type=\"hidden\" name=\"$employeeusernamelast\" value=\"$student\">");
	
        // ------- Display Name, Employee ID, Record # Information -----------------

	// store post to give to print function below
	$userinfoforpost = array();
	$userinfoforpost[$namebox] = $name_store;
	$userinfoforpost[$employeeid] =  $id_store;
	$userinfoforpost[$record] = $record_store;
	
	displayNameIdRecord($lockfields, $namebox, $employeeid, $record, $userinfoforpost);
	
        // ------- Display Pay Period Information -----------------
	
	// pass currently retrieved paydate value to selected_period
	$selected_period = $paydate;
	
	$paystart = displayPayPeriodDropDown($selected_period, $payperiod, $paydates, $payperiods, $maxpayperiod);
	
        // ------- Display Form -----------------
	
	displayTimesheet($status, $calcforpost, $paystart, $weekdays, $inputstyle, $lockfields, $totalhr, $totalmin, $sickhr, $vacationhr);
		
	// print rate, hour, total row
	displayRateTotalHours($rate_store, $twowktotal, $lockfields);
	

        // ------- Display Comments Box -----------------

	// print textarea for worker notes
	displayComments($comment_store, $lockfields, $commentbox, $status);
	
	// convert to html (otherwise ',",\ characters will cause strange textbox behavior
	$commentshtml = htmlentities($comment_store);
	$_POST[$commentbox] = $commentshtml;


        //----- Print Submit buttons -----

	// disable buttons depending on situation
	$disablebuttondeny = "";
	if(is_null($user_submitvalue) || is_null($super_approvevalue))
	{
		// if user has not submitted or supervisor has not approved, disable deny buttons
		$disablebuttondeny = "disabled";
	}
	$disablebuttonenter = "";
	if(is_null($user_submitvalue) || is_null($super_approvevalue) || !is_null($admin_enteredvalue))
	{
		// if not yet approved or already entered, disable enter button
		$disablebuttonenter = "disabled";
	}
	
	print("<p class=\"noprint\"><i>Click \"Deny\" below if errors are present or to unlock the timesheet for the employee to make changes. Click \"Change\" above to view another pay period without performing any action.</i></p>
	<input type=\"submit\" value=\"Entered in HR\" name=\"enter\" class=\"noprint\" $disablebuttonenter>
	<input type=\"button\" value=\"Print\" name=\"print\" class=\"noprint\" onClick=\"DoPrint();\">
	<input type=\"submit\" value=\"Deny\" name=\"deny\" class=\"noprint\" $disablebuttondeny>
	<script type=\"text/javascript\" language=\"JavaScript\"><!--
		function DoPrint()
		{
			// document.timesheet.submit();
			window.print();
		}
	//--> </script>
	</form>
			<!-- print signature lines at the bottom -->
			<br>
			<table>
			  <tr>
			    <td class=\"signature\">");
			    
			    // display electronic value of employee signature if submitted
			    if(!is_null($user_submitvalue))
			    {
				    print("$student $user_submitvalue");
			    }
		     print("</td><td class=\"signature\">");
		     	    
		     	    // display electronic value of supervisor signature if approved
			    if(!is_null($super_approvevalue))
			    {
				    print("$approvedby $super_approvevalue");
			    }
			
			    
	          print("   </td>
		          </tr>
		          <tr>
		             <td class=\"signature\">___________________________________ </td><td class=\"signature\">___________________________________ </td>
			  </tr>
			  <tr>
			    <td class=\"signature\">Employee Signature / Date</td><td class=\"signature\">Supervisor Signature / Date</td>
			  </tr>
			</table>
			<br><br>
			<!-- display usage notes -->
			");
        }//end account permission
    }//end require auth else
?>
		<!--end content container-->
		</div>
	<!--end container-->
	</div>
</body>
</html>

