<?php

/*
Copyright (c) 2004 Jason Lockhart

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.

Edited by Joshua Morris
Last Updated: 24 May 2012

*/

require_once "include/timesheetfunctions.php";
require_once "include/configuration.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet | Staff Summary</title>
<!-- Version 3.5.0 -->
</head>

<body>
<!-- header container -->
<div id="container">
	<?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Administrative Summary</div></div>"); ?>
		<!-- form container -->
		<div id="content_container">

<?php
// ------ Require Authentication to Show Timesheet, Else Redirect to Login Page ------------------------------------
$log_name = "t514ne";
$log_password = "t234pe";
$isvalidlogin = false;
$db_username='staff';

// get user id & password, cut to length for security
$user = @substr($_POST[$log_name],0,30);
$user_pass = @substr($_POST[$log_password],0,64);

// ------ TEST IF USER INFORMATION IS VALID -----------------------------------------------------------------------

$isvalidlogin = checkValidLogin($db_username, $user, $user_pass);

if(!$isvalidlogin)
{
	// login is not valid print redirect
	trigger_error("Nonvalid Login",E_USER_ERROR);
	
	// check if account locked
	if($login_store == 3)
	{
		print("<br>Too many failed login attempts, please verify your login credentials, wait 30 mintues and try again.<br><br>");
	}
}
else
// ------ If Login Valid, Continue on to Display Timesheet -----
{
    
    //----------------------------------------------------------------
    // Calculate Pay Period Information
    //----------------------------------------------------------------
    $results = calcPayPeriodInfo ();
    $paydates = $results[0];
    $payperiods = $results[1];
    $paydate = $results[2];
    $periodnumber = $results[3];
	
    		
    //----------------------------------------------------------------
    // Get the Selected List of Students for user
    //----------------------------------------------------------------

    // variables to store
    $payid_store = array();  // hold payids
    $submit_store = array(); // hold submit timestamps
    $approve_store = array(); // hold approve timestamps
    $enter_store = array(); // hold enter timestamps
    $employeename_store = array(); // hold employee names
    $supervisorname_store = array(); // hold supervisor names
    $supervisoruser_store = array(); // hold supervisor user names
    $employeeuser_store = array(); // hold employee user names


    // get user id, cut down to known length for security, no more than 30 characters
    $user = @substr($_POST[$log_name],0,30);

    // get the pay start date to query on, cut down to known length for security, no more than 8 characters
    $date = $paydate;
    if(isset($_POST[$payperiod]))
    {
            $date = @substr($_POST[$payperiod],0,8);
    }
		
    // query the view for timesheet select based on login & paydate
    $query = sprintf("SELECT * FROM vwsummarybypaystartbysupervisor WHERE paystart='%s' order by studentuser desc", mysql_real_escape_string($date));

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {
            $count = 0;
            // get results
            while($row = mysql_fetch_assoc($result))
            {
                    // store Pay_ID
                    $payid_store[$count] = $row['Pay_ID'];

                    // determine if payperiod is submitted for approval
                    $submit_store[$count] = $row['SubmitTimestamp'];

                    // determine if payperiod approved
                    $approve_store[$count] = $row['ApproveTimestamp'];

                    // determine if payperiod entered
                    $enter_store[$count] = $row['EnteredTimestamp'];

                    // get employee's name
                    $employeename_store[$count] = $row['studentsname'];

                    // get supervisor's name
                    $supervisorname_store[$count] = $row['supervisorname'];

                    // get supervisor user name
                    $supervisoruser_store[$count] = $row['supervisoruser'];

                    // get employee user name
                    $employeeuser_store[$count] = $row['studentuser'];

                    // get work study hours left
                    $hrs_store[$count] = $row['HrsLeft'];

                    // get work study hrs update timestamp
                    $hrsupdated_store[$count] = $row['HrsLastUpdate'];

                    $count++;
            }
    }//endelse !result
    
    //----------------------------------------------------------------
    // Check if logged in user has Staff permission
    //----------------------------------------------------------------

    $permission = checkValidPermissions($user, 'staff');
    
    if($permission)
    //account not disabled & user has permission 
    {

	//<!-- begin printing form with Post -->
	print("<br>\n<div id=\"payperiodbar\"><form name=\"timesheet\" action=\"timesheetstaffsummary.php\" method=\"POST\" >");
	
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	
        // ------- Display Pay Period Information -----------------
	
	// pass POST value to selected_period
	if(isset($_POST[$payperiod]))
        //if period is set maintain
        { 
            $selected_period = $_POST[$payperiod];
        }else{
        //else set to current payperiod
            $selected_period = $paydates[3];
        }
		
	$paystart = displayPayPeriodDropDown($selected_period, $payperiod, $paydates, $payperiods, $maxpayperiod);
	
	// print end select payperiod form
	print("</form></div>\n\n");
	
        // ------- Logout button -----------------
	print("<p align=\"right\"><a href=\"index.php\"><input type=\"button\" value=\"Logout\" name=\"logout\" class=\"noprint\" onClick=\"window.location='index.php'\"></a></p>\n\n");


        // ------- Begin Printing Summary form with Post -->
	print("<br><form name=\"summary\" action=\"timesheetstaffreview.php\" method=\"POST\" >");
	
	// maintain login information for the next page
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">
	       <input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">
	       <input type=\"hidden\" name=\"encrypted\" value=\"\">
	       <input type=\"hidden\" name=\"count\" value=\"$count\">
	       ");


        // ------- Display Student List -----------------

	// print beginning of table & header row
	print(" <!-- Students -->		
		<center>
		<br><br><br><!-- push table under payperiod bar -->
		<table id=\"summary\">
		<tr>
		  <th></th><th>Name</th><th>Submitted </th><th>&nbsp;&nbsp;Approved</th><th>&nbsp;&nbsp;Entered</th><th>&nbsp;&nbsp;Hrs Left</th><th>&nbsp;&nbsp;Hrs Updated</th><th>Supervisor</th><th></th>
		</tr>");
	
	// print employees and the status of the timesheets for the pay period
	while($count > 0)
	{
		// since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
		$count = $count - 1;
		
		// check to see if status if submitted or approved, default to image for false
		$submitimage = "alert.gif";
		$approveimage = "alert.gif";
		$enterimage = "alert.gif";
		
		// is submit timestamp has value, set submitted image to true
		if(!is_null($submit_store[$count]))
		{
			$submitimage = "statusfine.gif";
		}
		// if approve timestamp has value, set approve image to true
		if(!is_null($approve_store[$count]))
		{
			$approveimage = "statusfine.gif";
		}
		// if enter timestamp has value, set enter image to true
		if(!is_null($enter_store[$count]))
		{
			$enterimage = "statusfine.gif";
		}	
		
		// convert date to more readable text, if hrs left = 9999 then non-work study student
		$updatetime = "";
		$hrstime;
		$hrsclass = "";
		if($hrs_store[$count] != 9999)
		{
			// then limited funds employee student
			$updatetime = date("m/d/Y", strtotime($hrsupdated_store[$count]));
			$hrstime = $hrs_store[$count];
			
			// check if hrs lower than threshold, if so color field
			if($hrstime < $hrswarninglevel)
			{
				$hrsclass = "nonprintwarning";
			}
		}
		else
		{
			// then non-work study student, set hours to NA
			$hrstime = "NA";
		}
                
                //get email address
                $emailaddressemployee = getUserEmail($employeeuser_store[$count]);
                $emailaddresssuper = getUserEmail($supervisoruser_store[$count]);
		
		print("	
		<tr>
		  <!-- add email button with unique names and mouse rollover effect -->
		  <td>
		  	<a href=\"mailto:$emailaddressemployee\" onMouseover=\"document.employeeemail$count.src='email_buttongrayover.gif'\" onMouseout=\"document.employeeemail$count.src='email_buttongray.gif'\">
			<img src=\"email_buttongray.gif\" name=\"employeeemail$count\" class=\"styleimage\" alt=\"emailicon\"></a></td>
		  <!-- add employee name as a stylized input button linked to the timesheet to review it -->
		  <td>
		      	<input type=\"submit\" value=\"$employeename_store[$count]\" name=\"review$count\" class=\"stylebutton\" onmouseover=\"this.className='stylebuttonover'\" onmouseout=\"this.className='stylebutton'\">
			<input type=\"hidden\" value=\"$payid_store[$count]\" name=\"payidstore$count\">
		  </td>
		  <!-- add submitted status icon -->
		  <td>
		  	<img src=\"$submitimage\" alt=\"submitstatus\">
		  </td>
		  <!-- add approved status icon -->
		  <td> 
		  	<img src=\"$approveimage\" alt=\"approvestatus\">
		  </td>
		  <!-- add entered status icon -->
		  <td>
		  	<img src=\"$enterimage\" alt=\"enterstatus\">
		  </td>
		  <!-- add remaining work study hrs left -->
		  <td>
		    	<p class=\"$hrsclass\">$hrstime</p>
		  </td>
		  <!-- show when hrs last updated -->
		  <td>
		  	$updatetime
		  </td>
		  <!-- add supervisor name -->
		  <td>
		  	$supervisorname_store[$count]
		  </td>
		  <!-- add mail link for supervisor -->
		  <td>
		  	<a href=\"mailto:$emailaddresssuper\" onMouseover=\"document.superemail$count.src='email_iconwhite_smover.gif'\" onMouseout=\"document.superemail$count.src='email_iconwhite_sm.gif'\"><img src=\"email_iconwhite_sm.gif\" name=\"superemail$count\" class=\"styleimage\" alt=\"emailicon\"></a>
		  </td>
		</tr>
		");
		
	}//end while count > 0
	
	// print end of table
	print("	</table>
		</center>");
	
	// print end of form
	print("</form>\n");

        // ------- Print Usage Notes -----------------
	print("<div id=\"notes\">
	<!-- display usage notes -->
	<p>Click on an employee's name to review their timesheet for the period or deny it. Press \"Change\" to view another pay period. \"Hrs Left\" represents the number of work study hours remaining as of the last update, given in the \"Hrs Updated\" column. This number may be out of date if not recent and should serve as a general guideline only.</p>\n
	</div>");
	
	
        // ------- Print Symbol Legend -----------------
	print("<div id=\"legend\"> 
	<table>
	<tr><td><img src=\"statusfine.gif\" alt=\"fine\"></td><td>indicates that the step is completed.</td><tr> 
	<tr><td><img src=\"alert.gif\" alt=\"alert\"></td><td>indicates that the step is not yet complete.</td></tr> 
	<tr><td><img src=\"email_buttongray.gif\" alt=\"email\"></td><td>click to email the employee.</td></tr> 
	<tr><td><img src=\"email_iconwhite_sm.gif\" alt=\"email\"></td><td>click to to email the supervisor.</td></tr>
	</table>
	</div>\n");
	
        //------------------------------------------------
        // Print Link(Form) to Reports and Administrative Actions 
	//------------------------------------------------
        print("<div id=\"list\">\n"); //begin main table
	
        //------------------------------------------------
	print("<div class=\"list_item\">\n"); //begin section 1
	
	// Print Hours Entry Link
	print("
	<form name=\"hrsentry\" action=\"timesheetstaffhrsentry.php\" method=\"POST\" >");
	
	// maintain login information for the next page
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">
		<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">
		<input type=\"hidden\" name=\"encrypted\" value=\"\">
		<input type=\"hidden\" name=\"count\" value=\"$count\">
	       <br><b>Enter or Modify Limited Funds</b>
	       <br><br><input type=\"submit\" name=\"tohrsentry\" value=\"Go to Entry Form\" class=\"stylebutton\">
	</form>");
	
	// Print Inactive Users Link
	print("
	<form name=\"useractivity\" action=\"timesheetstaffuseractivity.php\" method=\"POST\" >");
	
	// maintain login information for the next page
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">
	       <input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">
	       <input type=\"hidden\" name=\"encrypted\" value=\"\">
	       <input type=\"hidden\" name=\"count\" value=\"$count\">
	       <br><b>View Inactive Users</b>
	       <br><br><input type=\"submit\" name=\"touseractivity\" value=\"Go to View Activity\" class=\"stylebutton\">
	</form>");
	
	print("</div>\n");//end section 1
        //------------------------------------------------
        
	print("<div class=\"list_item\">\n"); //begin section 2
	
	// Print Pay Rate Entry Link
	print("
	<form name=\"userrates\" action=\"timesheetstaffrateentry.php\" method=\"POST\" >");
	
	// maintain login information for the next page
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">
	       <input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">
	       <input type=\"hidden\" name=\"encrypted\" value=\"\">
	       <input type=\"hidden\" name=\"count\" value=\"$count\">
	       <br><b>Enter or Modify Employee Pay Rate</b>
	       <br><br><input type=\"submit\" name=\"torateentry\" value=\"Go to Entry Form\" class=\"stylebutton\">
	</form>");
	
	// Print Change Supervisor Link
	print("
	<form name=\"usersupervisor\" action=\"timesheetstaffsuperchange.php\" method=\"POST\" >");
	
	// maintain login information for the next page
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">
	       <input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">
	       <input type=\"hidden\" name=\"encrypted\" value=\"\">
	       <input type=\"hidden\" name=\"count\" value=\"$count\">
	       <br><b>Modify An Employee's Supervisor</b>
	       <br><br><input type=\"submit\" name=\"tosuperchange\" value=\"Go to Change Form\" class=\"stylebutton\"><br>
	</form>");
	
	print("</div>\n"); //end section 2
        //------------------------------------------------
        
        print("<div class=\"list_item\">\n"); //begin section 3
	
	// Print Manage User Accounts Link
	print("
	<form name=\"useraccounts\" action=\"timesheetstaffuseraccounts.php\" method=\"POST\" >");
	
	// maintain login information for the next page
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">
	       <input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">
	       <input type=\"hidden\" name=\"encrypted\" value=\"\">
	       <input type=\"hidden\" name=\"count\" value=\"$count\">
	       <br><b>Create User Accounts</b>
	       <br><br><input type=\"submit\" name=\"touseraccounts\" value=\"Go to User Accounts Form\" class=\"stylebutton\">
	</form>");
        
        // Print Manage User Info Link
	print("
	<form name=\"useraccounts\" action=\"timesheetstaffuserinfo.php\" method=\"POST\" >");
	
	// maintain login information for the next page
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">
	       <input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">
	       <input type=\"hidden\" name=\"encrypted\" value=\"\">
	       <input type=\"hidden\" name=\"count\" value=\"$count\">
	       <br><b>Manage User Info</b>
	       <br><br><input type=\"submit\" name=\"touserinfo\" value=\"Go to User Info Form\" class=\"stylebutton\">
	</form>");
	
	
	
	print("</div>\n"); //end section 3
        //------------------------------------------------
	
	print("</div>\n"); // end Reports & Administrative Actions
	
	
	// print footer
	print("<div id=\"footer\"><br><br></div>");
	
	
    }//end account permission
}//end require auth else
?>

		</div>
	</div>
</body>
</html>

