<?php

/*
Copyright (c) 2009 Joshua Morris
Last Updated: 24 May 2012

*/

require_once "include/timesheetfunctions.php";
require_once "include/configuration.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet | Change Supervisor</title>
<!-- Version 3.5.0 -->
</head>

<body>
<!-- header container -->
<div id="container">
	<?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Administrative Supervisor Change</div></div>"); ?>
		<!-- form container -->
		<div id="content_container">
<?php

// ------ Require Authentication to Show Timesheet, Else Redirect to Login Page ------------------------------------
$log_name = "t514ne";
$log_password = "t234pe";
$isvalidlogin = false;
$db_username='staff';

// get user id & password, cut to length for security
$user = @substr($_POST[$log_name],0,30);
$user_pass = @substr($_POST[$log_password],0,64);

// ------ TEST IF USER INFORMATION IS VALID -----------------------------------------------------------------------

$isvalidlogin = checkValidLogin($db_username, $user, $user_pass);

if(!$isvalidlogin)
{
	// login is not valid print redirect
	trigger_error("Nonvalid Login",E_USER_ERROR);
	
	// check if account locked
	if($login_store == 3)
	{
		print("<br>Too many failed login attempts, please verify your login credentials, wait 30 mintues and try again.<br><br>");
	}
	
}
else
// ------ If Login Valid, Continue on to Display Timesheet ---------
{
	
	
    //----------------------------------------------------------------
    // Calculate Pay Period Information
    //----------------------------------------------------------------
    $results = calcPayPeriodInfo ();
    $paydates = $results[0];
    $payperiods = $results[1];
    $paydate = $results[2];
    $periodnumber = $results[3];
	
    //----------------------------------------------------------------
    // Check if Update Supervisor is pressed
    //----------------------------------------------------------------

    if(isset($_POST['updatesuper']))
    {

            // read in submitted info
            $count = $_POST['count'];
            $queryfailed = 0;
            while($count > 0)
            {
                    // since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
                    $count = $count - 1;

                    // build field names
                    $supervisorcount = 'superdrop'.$count;
                    $superoldcount = 'superdropold'.$count;
                    $namecount = 'name'.$count;

                    // cut variables for security
                    $super_cut = @substr($_POST[$supervisorcount],0,30);  // new supervisor submitted
                    $user_cut = @substr($_POST[$namecount],0,30); // username stored in POST
                    $superold_cut = @substr($_POST[$superoldcount],0,30); // old rate store in POST

                    // only update if new value
                    if(strcmp($super_cut,$superold_cut) != 0)
                    {

                            // check that supervisor is not being set to the user itself
                            if(strcmp($super_cut,$user_cut) != 0)
                            {

                                    print("Supervisor for $user_cut updated from $superold_cut to $super_cut.<br>");

                                    // send update query to change supervisor
                                    $query = sprintf("SELECT UpdateSupervisorEntry ('%s','%s')", mysql_real_escape_string($user_cut), mysql_real_escape_string($super_cut));

                                    // execute
                                    $result = mysql_query($query);

                                    // if query failed
                                    if(!$result)
                                    {
                                            $queryfailed = 1;
                                    }
                            }else{
                                    // given message that a user cannot be there own supervisor
                                    print("An employee is not allowed to be their own supervisor, please select a different supervisor for $user_cut.<br>\n");
                            }//end else user != super

                    }//end if new name != old name

            }

            // check if any queries failed
            if($queryfailed == 1)
            {			
                    trigger_error("No connection",E_USER_ERROR);
            }

    }//end if isset updatesuper

    //----------------------------------------------------------------
    // Get the list of students to display option of changing
    //----------------------------------------------------------------

    // variables to store
    /*$payid_store = array();  // hold payids*/
    $employeename_store = array(); // hold employee names
    $employeeuser_store = array(); // hold employee user names

    // query the view for all active users
    $query = sprintf("SELECT * FROM vwusersactive");

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {

            trigger_error("List employees",E_USER_ERROR);
    }
    else
    {
            $count_users = 0;
            // get results
            while($row = mysql_fetch_assoc($result))
            {
                    // get employee's name
                    $employeename_store[$count_users] = $row['name'];

                    // get supervisor user name
                    $supervisoruser_store[$count_users] = $row['Supervisor'];

                    // get employee user name
                    $employeeuser_store[$count_users] = $row['user'];

                    $count_users = $count_users + 1;
            }

    }//endelse !result

    //----------------------------------------------------------------
    // Get the list of supervisors that are in the system
    //----------------------------------------------------------------

    // variables to store
    $supervisorlistname_store = array();  // hold list of supervisor full names
    $supervisorlistuser_store = array();  // hold list of supervisor user ids


    // query the view for all active supervisors
    $query = sprintf("SELECT * FROM vwallsupervisors");

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("List supervisors",E_USER_ERROR);
    }
    else
    {
            $count_supers = 0;
            // get results
            while($row = mysql_fetch_assoc($result))
            {
                    // get supervisor username and full name
                    $supervisorlistname_store[$count_supers] = $row['name'];
                    $supervisorlistuser_store[$count_supers] = $row['user'];

                    $count_supers = $count_supers + 1;
            }
    }//end results

    //----------------------------------------------------------------
    // Check if logged in user has Staff permission
    //----------------------------------------------------------------

    $query = sprintf("SELECT * FROM vwuserpermissions WHERE user = '%s'", mysql_real_escape_string($user));

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {
            // get results
            $row = mysql_fetch_assoc($result);

            // store IsUser permission to check if user has permission to view this sheet
            $isstaff = $row['IsAdmin'];

            // store status permission to check if user has permission to view this sheet
            $status = $row['status'];
    }
    
    //----- Check if User Account is Disabled ---------------------------------------------------------------
    if($status == 'D')
    {
            trigger_error("Account disabled",E_USER_ERROR);
    }
    elseif($isstaff == 0)
    {
            trigger_error("Account permission",E_USER_ERROR);
    }
    else
    //account not disabled & user has permission to fill out a timesheet
    {

        // ------- Display Return to Summary Button -----------------

	//<!-- return to summary page form -->
	print("<br><form name=\"returntosummary\" action=\"timesheetstaffsummary.php\" method=\"POST\" >");
	
	// pass login name & password to remain logged in
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	
	// pass payperiod selected
	print("<input type=\"hidden\" name=\"$payperiod\" value=\"$paydate\">");
	
	// add back to summary button
	print("<input type=\"submit\" name=\"backtosummary\" value=\"Back to Summary\" class=\"noprint\">");
	print("</form>\n");

        // ------- Begin Change Supervisor Form -----------------

	//<!-- review timesheet form with Post -->
	print("<br><form name=\"rateentry\" action=\"timesheetstaffsuperchange.php\" method=\"POST\" >");
	
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	print("<input type=\"hidden\" name=\"count\" value=\"$count_users\">");

        // ------- Display Student List -----------------

	// print beginning of table & header row
	print(" <!-- Students -->		
		<center>
		<table id=\"summary\">
		<tr>
		  <th></th><th>Name</th><th>New Supervisor</th><th>&nbsp;Current Supervisor</th><th>&nbsp;&nbsp;</th>
		</tr>");
	
	// print information for each employee, cycle back through in same order so alphabetical by username
	$count2 = 0;
	while($count2 < $count_users)
	{
            //get email address
            $emailaddressemployee = getUserEmail($employeeuser_store[$count2]);
            $emailaddresssuper = getUserEmail($supervisoruser_store[$count2]);

            print("	
            <tr>
                <!-- add email button with unique names and mouse rollover effect -->
                <td>
                    <a href=\"mailto:$emailaddressemployee\" onMouseover=\"document.employeeemail$count2.src='email_buttongrayover.gif'\" onMouseout=\"document.employeeemail$count2.src='email_buttongray.gif'\">
                    <img src=\"email_buttongray.gif\" name=\"employeeemail$count2\" class=\"styleimage\" alt=\"emailicon\"></a></td>
                <!-- add employee name -->
                <td>
                    $employeename_store[$count2]
                </td>
                <!-- add input for new supervisor entry -->
                <td>
                    <select name=\"superdrop$count2\" value=\"$supervisoruser_store[$count2]\">
                            <option>$supervisoruser_store[$count2]</option>");

                    // print list of supervisors into dropdown
                    $count3 = 0;
                    // get results
                    while($count3 < $count_supers)
                    {
                            if(strcmp($supervisoruser_store[$count2],$supervisorlistuser_store[$count3]) != 0)
                            {
                                    print("<option>$supervisorlistuser_store[$count3]</option>");
                            }

                            $count3 = $count3 + 1;
                    }
                print("
                    </select>
                    <input type=\"hidden\" name=\"name$count2\" value=\"$employeeuser_store[$count2]\">
                    <input type=\"hidden\" name=\"superdropold$count2\" value=\"$supervisoruser_store[$count2]\">
                </td>		  
                <!-- display current supervisor -->
                <td>
                    $supervisoruser_store[$count2]
                </td>
                <!-- add mail link for supervisor -->
                <td>
                    <a href=\"mailto:$emailaddresssuper\" onMouseover=\"document.superemail$count2.src='email_iconwhite_smover.gif'\" onMouseout=\"document.superemail$count2.src='email_iconwhite_sm.gif'\"><img src=\"email_iconwhite_sm.gif\" name=\"superemail$count2\" class=\"styleimage\" alt=\"emailicon\"></a>
                </td>
            </tr>
            ");

            // since array is zero indexed (i.e. count = 1 then one value stored at employeename_store[0]
            $count2 = $count2 + 1;
	}
	
	// print end of table
	print("</table><br>\n");
		
	// print Submit button
	print("<input type=\"submit\" value=\"Update Supervisor\" name=\"updatesuper\"></center>\n");
	
	// print end of form
	print("</form>\n");
	
	// print usage notes
	// ------- Print Usage Notes -----------------
	print("<div id=\"notes\">
	<!-- display usage notes -->
	<p>Select a new supervisor for those employees whose supervisor needs to be changed. Note that only current supervisors in the system are listed. If the name you desire does not show up, please have an account created for them. To submit changes press \"Update Supervisor\".</p>
	</div>\n");
	
	// print symbol legend
	
	print("<div id=\"legend\"> 
	<table>
	<tr><td><img src=\"email_buttongray.gif\" alt=\"email\"></td><td>click to email the employee.</td></tr> 
	<tr><td><img src=\"email_iconwhite_sm.gif\" alt=\"email\"></td><td>click to to email the supervisor.</td></tr>
	</table>
	</div>");
	
	/*// print list
	
	print("<div id=\"list\">
	<p><b></b><br><br>");
	
	// print end of list 
	print("</p>
	</div>");*/
	
	// print footer
	print("<div id=\"footer\"><br><br></div>");
	
}//end account not disabled
}//end require auth else
?>

		</div>
	</div>
</body>
</html>

