<?php

/*
Copyright (c) 2009 Joshua Morris
Last Updated: 24 May 2012

*/

require_once "include/timesheetfunctions.php";
require_once "include/configuration.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet | User Accounts</title>
<!-- Version 3.5.0 -->
</head>

<body>
<!-- header container -->
<div id="container">
	<?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Administrative Manage User Accounts</div></div>"); ?>
		<!-- form container -->
		<div id="content_container">
<?php

// ------ Require Authentication to Show Timesheet, Else Redirect to Login Page ------------------------------------
$log_name = "t514ne";
$log_password = "t234pe";
$isvalidlogin = false;
$db_username='staff';

// get user id & password, cut to length for security
$user = @substr($_POST[$log_name],0,30);
$user_pass = @substr($_POST[$log_password],0,64);

// ------ TEST IF USER INFORMATION IS VALID -----------------------------------------------------------------------

$isvalidlogin = checkValidLogin($db_username, $user, $user_pass);

if(!$isvalidlogin)
{
	// login is not valid print redirect
	trigger_error("Nonvalid Login",E_USER_ERROR);
	
	// check if account locked
	if($login_store == 3)
	{
		print("<br>Too many failed login attempts, please verify your login credentials, wait 30 mintues and try again.<br><br>");
	}
	
}
else
// ------ If Login Valid, Continue on to Display Timesheet ---------
{
	
	
    //----------------------------------------------------------------
    // Calculate Pay Period Information
    //----------------------------------------------------------------
    $results = calcPayPeriodInfo ();
    $paydates = $results[0];
    $payperiods = $results[1];
    $paydate = $results[2];
    $periodnumber = $results[3];
    
    //----------------------------------------------------------------
    // Check if Remove is pressed
    //----------------------------------------------------------------

    if(isset($_POST['remove']))
    {
        $count = 0;
        $previousrequests = intval($_POST['count']); //ensure posted value is integer
        while($count < $previousrequests)
        {
            $post = "removependingaccount$count";
            if(isset($_POST[$post]))
            {
                $field = "accountid$count"; // form post field name
                if(empty($_POST[$field]))
                //check for empty value
                {
                    trigger_error("Pending remove",E_USER_ERROR);
                }
                else
                {
                    $accountidclean = intval($_POST[$field]); // ensure post is integer
                
                    // call RemovePending for accountid             
                    $query = sprintf("SELECT RemovePending('%s') as pending",mysql_real_escape_string($accountidclean));
                    // execute
                    $result = mysql_query($query);
                    // check results
                    if(!$result)
                    // if query fails
                    {
                        trigger_error("Pending remove",E_USER_ERROR);
                    }
                }//endelse
            }//endif isset removepending
            $count++;
        }
    }//end isset remove
    
    //----------------------------------------------------------------
    // Check if Create is pressed
    //----------------------------------------------------------------
    if(isset($_POST['create']))
    {
        $count = 0;
        $previousrequests = intval($_POST['count']); //ensure posted value is integer
        while($count < $previousrequests)
        // cyle through requests and check for those marked for creation
        {
            $post = "createaccount$count";
            if(isset($_POST[$post]))
            // if marked for creation
            {
                $field = "accountid$count"; // get accountid
                if(empty($_POST[$field]))
                //if no account id found
                {
                    trigger_error("Account id",E_USER_ERROR);
                }
                else
                // account id found
                {
                    
                    //--------------------------------
                    // Get pending acount information for account creation based on accountid
                    $accountidclean = intval($_POST[$field]); // ensure post is integer
                    // query the view for the pending user
                    $query = sprintf("SELECT * FROM vwpendingaccounts WHERE accountid='%s'",mysql_real_escape_string($accountidclean));
                    // execute
                    $result = mysql_query($query);
                    // if query failed
                    if(!$result)
                    {
                            trigger_error("No connection",E_USER_ERROR);
                    }
                    else
                    {
                        //get user info to create
                        while($row = mysql_fetch_assoc($result))
                        {
                            // get employee's name
                            $name = $row['name'];
                            // get user name
                            $username = $row['user'];
                            // get user id
                            $id = $row['empnum'];
                            // get encrypted password
                            $password = $row['desiredpassword'];
                        }//endwhile
                        
                        //--------------------------
                        // Get selected role and fulltime values from form
                        
                        $role = intval($_POST['role']); // get role
                        
                        // get whether fulltime or not
                        $fulltime = 0;
                        $field = "fulltime$count";
                        if(isset($_POST[$field]))
                        {
                            $fulltime = 1;
                        }
                        
                        //---------------------------
                        // Create account
                        
                        $query = sprintf("SELECT CreateAccount('%s', '%s', '%s', '%s', '%s', '%s')",mysql_real_escape_string($name),mysql_real_escape_string($id),mysql_real_escape_string($username),mysql_real_escape_string($password),mysql_real_escape_string($role),mysql_real_escape_string($fulltime));
                        // execute
                        $result = mysql_query($query);
                        
                        if(!$result)
                        {
                            trigger_error("Account creation",E_USER_ERROR);
                        }//endif
                        
                        //----------------------------
                        // Remove created account from pending list
                        
                        $field = "accountid$count"; // form post field name
                        if(empty($_POST[$field]))
                        //check for empty value
                        {
                            trigger_error("Pending remove",E_USER_ERROR);
                        }
                        else
                        {
                            $accountidclean = intval($_POST[$field]); // ensure post is integer

                            // call RemovePending for accountid             
                            $query = sprintf("SELECT RemovePending('%s') as pending",mysql_real_escape_string($accountidclean));
                            // execute
                            $result = mysql_query($query);
                            // check results
                            if(!$result)
                            // if query fails
                            {
                                trigger_error("Pending remove",E_USER_ERROR);
                            }else{
                                print("<p style=\"color:green\">Account <i>$username</i> for $name has been created.</p>");
                            }
                        }//endelse
                       
                    }//endelse
                
                }//endelse
            }//endif
        
            $count++;
        }//endwhile
    }//end isset create
    
    //----------------------------------------------------------------
    // Get all pending accounts
    //----------------------------------------------------------------
    
    // variables to store
    $accountids = array(); // holds account ids
    $name_store = array();  // holds names
    $username_store = array(); // holds user names
    $id_store = array(); // holds ids 
    $password_store = array(); // holds passwords
    $role_store = array();  // holds roles
    $reset_store = array(); // holds reset field

    // query the view for all active users
    $query = sprintf("SELECT * FROM vwpendingaccounts");

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {
            $count_users = 0;
            // get results
            while($row = mysql_fetch_assoc($result))
            {
                    // get account id
                    $accountids[$count_users] = $row['accountid'];
                
                    // get employee's name
                    $name_store[$count_users] = $row['name'];

                    // get user name
                    $username_store[$count_users] = $row['user'];

                    // get user id
                    $id_store[$count_users] = $row['empnum'];
                    
                    // get encrypted password
                    $password_store[$count_users] = $row['desiredpassword'];
                    
                    // get role
                    $role_store[$count_users] = $row['role'];

                    // get reset
                    if($row['reset'] != 'y')
                    {
                        $reset_store[$count_users] = "No";
                    }else{
                        $reset_store[$count_users] = "Yes";
                    }
                    
                    $count_users++;
            }
    }//endelse !result

    //----------------------------------------------------------------
    // Check if logged in user has Staff permission
    //----------------------------------------------------------------

    $permission = checkValidPermissions($user, 'staff');
    
    if($permission)
    //account not disabled & user has permission to fill out a timesheet
    {

        // ------- Display Return to Summary Button -----------------

	//<!-- return to summary page form -->
	print("<br><form name=\"returntosummary\" action=\"timesheetstaffsummary.php\" method=\"POST\" >");
	
	// pass login name & password to remain logged in
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	
	// pass payperiod selected
	print("<input type=\"hidden\" name=\"$payperiod\" value=\"$paydate\">");
	
	// add back to summary button
	print("<input type=\"submit\" name=\"backtosummary\" value=\"Back to Summary\" class=\"noprint\">");
	print("</form>\n");

        // ------- Pending Accounts List -----------------

	//<!-- review timesheet form with Post -->
	print("<br><form name=\"pendingaccounts\" action=\"timesheetstaffuseraccounts.php\" method=\"POST\" >");
	
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	print("<input type=\"hidden\" name=\"count\" value=\"$count_users\">");

        // ------- Display User List -----------------

	// print beginning of table & header row
	print(" <!-- Pending Accounts -->		
		<center>
                <h2>Pending Account Requests</h2>");
	
	// print information for each employee, cycle back through in same order so alphabetical by username
	$count = 0;
        $num = count($name_store);
        if($num == 0)
        {
            print("<p>No pending account requests</p>");
        }
        else
        {
            print("<table id=\"summary\">
		<tr>
		  <th>Name</th><th style=\"width:135px;\">ID Number</th><th style=\"width:135px;\">Role</th>
                  <th style=\"width:100px;\">Reset</th><th class=\"leftborder\">&nbsp;Create Account</th><th style=\"width:100px;\">Full-time</th>
                  <th style=\"width:135px;\">Roles</th><th>Remove</th>
		</tr>");
            
            while($count < $num)
            {

                print("	
                    <tr>
                        <!-- display employee name -->
                        <td>$name_store[$count]</td>
                        <!-- display id number -->
                        <td>$id_store[$count]<input type=\"hidden\" value=\"$accountids[$count]\" name=\"accountid$count\"/></td>		  
                        <!-- display role -->
                        <td>$role_store[$count]</td>
                        <!-- dislpay reset bit -->
                        <td>$reset_store[$count]</td>                
                        <!-- insert checkbox for account creation -->
                        <td class=\"leftborder\"><input type=\"checkbox\" name=\"createaccount$count\" /></td>
                        <!-- insert checkbox for parttime -->
                        <td><input type=\"checkbox\" name=\"fulltime$count\" /></td>                   
                        <!-- insert roles select -->
                        <td>
                            <select name=\"role\">
                                <option value=\"1\">Employee</option>
                                <option value=\"2\">Supervisor</option>
                                <option value=\"4\">Administrative</option>
                                <option value=\"3\>Employee + Supervisor</option>
                                <option value=\"5\">Employee + Administrative</option>
                                <option value=\"6\">Supervisor + Administrative</option>
                                <option value=\"7\">Employee + Supervisor + Administrative</option>
                            </select>
                        </td>
                        <!-- insert checkbox for removing pending account -->
                        <td><input type=\"checkbox\" name=\"removependingaccount$count\" /></td>

                ");

                print("</tr>");

                $count++;
            }//endwhile
        }//endelse
	// print end of table
	print("</table><br>\n");
		
	// print Submit button
	print("<input type=\"submit\" value=\"Create Accounts\" name=\"create\"><input type=\"submit\" value=\"Remove Marked\" name=\"remove\"></center>\n");
	
	// print end of form
	print("</form>\n");
	
	// print usage notes
	// ------- Print Usage Notes -----------------
	print("<div id=\"notes\">
	<!-- display usage notes -->
	<p>Above are pending account creation requests. To create accounts for the current users with their supplied password, check 'Create Account' 
        and select the appropriate role(s). Note that created accounts are assumed to be part-time unless the 'Full-time' checkbox is checked. 
        Press \"Create Accounts\" to create accounts for all marked users. </p>
        
        <p>Use the other administrative forms to set a supervisor, change pay rate, or set limited funds.</p>
        
        <p>To remove pending requests from the 
        queue, check 'Remove' and press \"Remove Marked\".  </p>
	</div>\n");
	
	// print symbol legend
	
	print("<div id=\"legend\"> 
	<table>
	<!--tr><td><img src=\"email_buttongray.gif\" alt=\"email\"></td><td>click to email the employee.</td></tr--> 
	</table>
	</div>");
	
	// print footer
	print("<div id=\"footer\"><br><br></div>");
	
    }//end account permission
}//end require auth else
?>

		</div>
	</div>
</body>
</html>

