<?php

/*
Copyright (c) 2004 Jason Lockhart

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.

Edited by Joshua Morris
Last Updated: 24 May August 2012
Version 3.5.0

*/

require_once "include/timesheetfunctions.php";
require_once "include/configuration.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet | User Activity</title>
<!-- Version 3.5.0 -->
</head>

<body>
<!-- header container -->
<div id="container">
	<?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Administrative View Employee Activity</div></div>"); ?>
		<!-- form container -->
		<div id="content_container">
<?php

// ------ Require Authentication to Show Timesheet, Else Redirect to Login Page ------------------------------------
$log_name = "t514ne";
$log_password = "t234pe";
$isvalidlogin = false;
$db_username='staff';

// get user id & password, cut to length for security
$user = @substr($_POST[$log_name],0,30);
$user_pass = @substr($_POST[$log_password],0,64);

// ------ TEST IF USER INFORMATION IS VALID -----------------------------------------------------------------------

$isvalidlogin = checkValidLogin($db_username, $user, $user_pass);

if(!$isvalidlogin)
{
	// login is not valid print redirect
	trigger_error("Nonvalid Login",E_USER_ERROR);
	
	// check if account locked
	if($login_store == 3)
	{
		print("<br>Too many failed login attempts, please verify your login credentials, wait 30 mintues and try again.<br><br>");
	}	
	
}
else
{
    // ------ If Login Valid, Continue on to Display Timesheet ----------------------------------------------------------

    //----------------------------------------------------------------
    // Calculate Pay Period Information
    //----------------------------------------------------------------
    $results = calcPayPeriodInfo ();
    $paydates = $results[0];
    $payperiods = $results[1];
    $paydate = $results[2];
    $periodnumber = $results[3];
    
    //----------------------------------------------------------------
    // Get the Selected List of Students for user
    //----------------------------------------------------------------

    // variables to store
    $employeeuser_store = array(); // hold employee user names
    $inactivecount_store = array(); // hold number of periods employee has been inactive

    // get user id, cut down to known length for security, no more than 30 characters
    $user = @substr($_POST[$log_name],0,30);

    // query the view for timesheet select based on login & paydate
    $query = sprintf("SELECT * FROM vwusersnotactive");

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {
            $count = 0;
            // get results
            while($row = mysql_fetch_assoc($result))
            {
                    // get employee's name
                    $employeename_store[$count] = $row['name'];

                    // get supervisor user name
                    $supervisoruser_store[$count] = $row['supervisor'];

                    // get employee user name
                    $employeeuser_store[$count] = $row['user'];

                    // get number of pay periods employee has been inactive
                    $inactivecount_store[$count] = $row['count'];

                    $count = $count + 1;
            }

    }//endelse !result


    //----------------------------------------------------------------
    // Check if logged in user has Staff permission
    //----------------------------------------------------------------

    $permission = checkValidPermissions($user, 'staff');
    
    if($permission)
    //account not disabled & user has permission to fill out a timesheet
    {

        // ------- Display Return to Summary Button -----------------

	//<!-- return to summary page form -->
	print("<br><form name=\"returntosummary\" action=\"timesheetstaffsummary.php\" method=\"POST\" >");
	
	// pass login name & password to remain logged in
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	
	// pass payperiod selected
	print("<input type=\"hidden\" name=\"$payperiod\" value=\"$paydate\">");
	
	// add back to summary button
	print("<input type=\"submit\" name=\"backtosummary\" value=\"Back to Summary\" class=\"noprint\">");
	print("</form>\n");

// ------- Begin Hours Form -----------------
	
	//<!-- review timesheet form with Post -->
	print("<br><form name=\"useractivity\" action=\"timesheetstaffuseractivity.php\" method=\"POST\" >");
	
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	print("<input type=\"hidden\" name=\"count\" value=\"$count\">");
        
        // check if any employees listed
	if($count < 1)
	{
		$nosheets = true;
	}else{

            // ------- Display Student List -----------------

            // print beginning of table & header row
            print(" <!-- Students -->		
                    <center>
                    <table id=\"summary\">
                    <tr>
                    <th></th><th>Name</th><th>&nbsp;&nbsp;Pay Periods Inactive</th><th>&nbsp;&nbsp;Supervisor</th><th></th>
                    </tr>");

            // print employees and the status of the timesheets for the pay period
            // cycle back through in same order so alphabetical by last name.
            $count2 = 0;
            while($count2 < $count)
            {
                //get email address
                $emailaddressemployee = getUserEmail($employeeuser_store[$count2]);
                $emailaddresssuper = getUserEmail($supervisoruser_store[$count2]);

                print("	
                <tr>
                <!-- add email button with unique names and mouse rollover effect -->
                <td>
                        <a href=\"mailto:$emailaddressemployee\" onMouseover=\"document.employeeemail$count2.src='email_buttongrayover.gif'\" onMouseout=\"document.employeeemail$count2.src='email_buttongray.gif'\">
                        <img src=\"email_buttongray.gif\" name=\"employeeemail$count2\" class=\"styleimage\" alt=\"emailicon\"></a></td>
                <!-- add employee name -->
                <td>
                        $employeename_store[$count2]
                </td>
                <!-- add number of periods inactive -->
                <td>
                        ($inactivecount_store[$count2])");

                        if($inactivecount_store[$count2] > 0)
                        {
                                // print data for current period
                                print(" $paydate");
                        }
                        if($inactivecount_store[$count2] > 1)
                        {
                                // print data for last period
                                print(", $paydates[2]");
                        }
                        if($inactivecount_store[$count2] > 2)
                        {
                                // print data for last period
                                print(", $paydates[1]");
                        }

                print("
                </td>
                <!-- add supervisor id -->
                <td>
                        $supervisoruser_store[$count2]
                </td>
                <!-- add mail link for supervisor -->
                <td>
                        <a href=\"mailto:$emailaddresssuper\" onMouseover=\"document.superemail$count2.src='email_iconwhite_smover.gif'\" onMouseout=\"document.superemail$count2.src='email_iconwhite_sm.gif'\"><img src=\"email_iconwhite_sm.gif\" name=\"superemail$count2\" class=\"styleimage\" alt=\"emailicon\"></a>
                </td>
                </tr>
                ");

                // since array is zero indexed (i.e. count = 1 then one value stored at employeename_store[0]
                $count2 = $count2 + 1;
            }

            // print end of table
            print("	</table>
                    </center>");
        }//endelse
        //
        // print notification if no timesheets saved
	if($nosheets)
	{
		print("<p><font color=\"red\">**</font>There are currently no inactive employees.<font color=\"red\">**</font></p>");
	}
		
	// print usage notes
	// ------- Print Usage Notes -----------------
	print("<div id=\"notes\">
	<!-- display usage notes -->
	<p>The above students have not filled out any time sheets for the number of pay periods displayed above. The more pay periods listed, 
        the longer they have been inactive. This may mean that they no longer work for the unit, have taken a leave of absence, or have forgotten
        to fill out timesheets.</p> 
        <p>Note that this report is generated dynamically and reports only the last three pay periods, including the current pay period.</p>
	</div>");
	
	// print symbol legend
	
	print("<div id=\"legend\"> 
	<table>
	<tr><td><img src=\"email_buttongray.gif\" alt=\"email\"></td><td>click to email the employee.</td></tr> 
	<tr><td><img src=\"email_iconwhite_sm.gif\" alt=\"email\"></td><td>click to to email the supervisor.</td></tr>
	</table>
	</div>");
	
	// print footer
	print("<div id=\"footer\"><br><br></div>");
	
    }//end account permission
}//end require auth else
?>

		</div>
	</div>
</body>
</html>

