<?php

/*

Edited by Joshua Morris
Last Updated: 24 May 2012

*/

require_once "include/timesheetfunctions.php";
require_once "include/configuration.php";

// Begin printing document 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<?php printPageHeader (); ?>
<title>Timesheet | Supervisor Summary</title>
<!-- Version 3.5.0 -->
</head>

<body>
<!-- header container -->
<div id="container">
	<?php print("<div id=\"h1\" class=\"noprint\"><a href=\"$logourl\"><img src=\"include\logo.gif\" alt=\"$logoalt\"></a> <div id=\"h2\">Supervisor Summary</div></div>"); ?>
		<!-- form container -->
		<div id="content_container">
<?php

// ------ Require Authentication to Show Timesheet, Else Redirect to Login Page ------------------------------------
$isvalidlogin = false;
$db_username='super';
// get user id & password, cut to length for security
$user = @substr($_POST[$log_name],0,30);
$user_pass = @substr($_POST[$log_password],0,64);

// ------ TEST IF USER INFORMATION IS VALID -----------------------------------------------------------------------

$isvalidlogin = checkValidLogin($db_username, $user, $user_pass);

if(!$isvalidlogin)
//if login errors for any reason
{
	// login is not valid print redirect
	trigger_error("Nonvalid Login",E_USER_ERROR);
	
	// check if account locked
	if($login_store == 3)
	{
		print("<br>Too many failed login attempts, please verify your login credentials, wait 30 mintues and try again.<br><br>");
	}
}
else
// ------ If Login Valid, Continue on to Display Timesheet -------------------------
{
    //----------------------------------------------------------------
    // Calculate Pay Period Information
    //----------------------------------------------------------------
    $results = calcPayPeriodInfo ();
    $paydates = $results[0];
    $payperiods = $results[1];
    $paydate = $results[2];
    $periodnumber = $results[3];
   	
    //----------------------------------------------------------------
    // Get the Selected List of Students for the supervisor for the pay period
    //----------------------------------------------------------------

    // variables to store
    $payid_store = array();  // hold payids
    $submit_store = array(); // hold submit timestamps
    $approve_store = array(); // hold approve timestamps
    $employeename_store = array(); // hold employee names
    $employeeuser_store = array(); // hold employee username
    $hrs_store = array(); // hold work study hours left, if available
    $hrsupdated_store = array(); // hold timestamp of when work study hrs last updated

    // get user id, cut down to known length for security, no more than 30 characters
    $user = @substr($_POST[$log_name],0,30);

    // get the pay start date to query on, cut down to known length for security, no more than 8 characters
    $date = $paydate;
    if(isset($_POST[$payperiod]))
    {
            $date = @substr($_POST[$payperiod],0,8);
    }
		
    // query the view for timesheet select based on login & paydate
    $query = sprintf("SELECT * FROM vwsummarybypaystartbysupervisor WHERE supervisoruser='%s' AND paystart='%s' order by studentuser desc", mysql_real_escape_string($user), mysql_real_escape_string($date));

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {
            $count = 0;
            // get results
            while($row = mysql_fetch_assoc($result))
            {
                    // store Pay_ID
                    $payid_store[$count] = $row['Pay_ID'];

                    // determine if payperiod is submitted for approval
                    $submit_store[$count] = $row['SubmitTimestamp'];

                    // determine if payperiod approved
                    $approve_store[$count] = $row['ApproveTimestamp'];

                    // get employee's name
                    $employeename_store[$count] = $row['studentsname'];

                    // get employee user name
                    $employeeuser_store[$count] = $row['studentuser'];
                    
                    // get work study hours left
                    $hrs_store[$count] = $row['HrsLeft'];

                    // get work study hrs update timestamp
                    $hrsupdated_store[$count] = $row['HrsLastUpdate'];

                    $count = $count + 1;
            }

    }//endelse !result

    //----------------------------------------------------------------
    // Get the List of Students currently supervised by user
    //----------------------------------------------------------------

    // variables to store
    $listemployees_store = array();  // hold list of employees

    // query the view for timesheet select based on login
    $query = sprintf("SELECT * FROM vwemployeesforsuper WHERE Supervisor='%s' order by user desc", mysql_real_escape_string($user));

    // execute
    $result = mysql_query($query);

    // if query failed
    if(!$result)
    {
            trigger_error("No connection",E_USER_ERROR);
    }
    else
    {
            $listcount = 0;
            // get results
            while($row = mysql_fetch_assoc($result))
            {
                    // list only employees who are not disabled
                    $liststatus = $row['status'];
                    if($liststatus != 'D')
                    {
                            // store employee name
                            $listemployee_store[$listcount] = $row['name']; 

                            $listcount++;
                    }
            }

    }//endelse !result


    //----------------------------------------------------------------
    // Check if logged in user has Supervisor permission
    //----------------------------------------------------------------

    $permission = checkValidPermissions($user, 'super');
    
    if($permission)
    //account not disabled & user has permission 
    {
	//<!-- begin printing form with Post -->
	print("<br>\n<div id=\"payperiodbar\"><form name=\"timesheet\" action=\"timesheetsupersummary.php\" method=\"POST\" >");
	
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">");
	print("<input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">");
	print("<input type=\"hidden\" name=\"encrypted\" value=\"\">");
	
        // ------- Display Pay Period Information -----------------
	
	// pass POST value to selected_period
	if(isset($_POST[$payperiod]))
        //if period is set maintain
        { 
            $selected_period = $_POST[$payperiod];
        }else{
        //else set to current payperiod
            $selected_period = $paydates[3];
        }
	
	$paystart = displayPayPeriodDropDown($selected_period, $payperiod, $paydates, $payperiods, $maxpayperiod);
	
	// print end select payperiod form
	print("</form></div>\n\n");
	

        // ------- Logout button -----------------
	print("<p align=\"right\"><a href=\"index.php\"><input type=\"button\" value=\"Logout\" name=\"logout\" class=\"noprint\" onClick=\"window.location='index.php'\"></a></p>\n\n");

        // ------- Begin Printing Summary form with Post -->
	print("<br><form name=\"summary\" action=\"timesheetsuperreview.php\" method=\"POST\" >");
	
	// maintain login information for the next page
	print("<input type=\"hidden\" name=\"$log_name\" value=\"$_POST[$log_name]\">
	       <input type=\"hidden\" name=\"$log_password\" value=\"$_POST[$log_password]\">
	       <input type=\"hidden\" name=\"encrypted\" value=\"\">
	       <input type=\"hidden\" name=\"count\" value=\"$count\">
	       ");


        // ------- Display Student List -----------------

	// variable to store if there are no timesheets for current supervisor and pay period - would print directly on the page except for IE7 repaint issue, hence moving to Notes instead. This repaint issue not found in Firefox, IE8, or Safari
	$nosheets=false;

	// print beginning of table & header row
	print(" <!-- Students -->		
		<center>
		<br><br><!-- push table under payperiod bar -->");
	
	// check if any employees have submitted timesheets for this payperiod
	if($count < 1)
	{
		$nosheets = true;
	}else
	{
		
		print("	<p>Employees who have filled out timesheets for this period</p>
			<table id=\"summary\">
			<tr>
			<th></th><th>Name</th><th>Submitted</th><th>&nbsp;&nbsp;Approved</th><th>&nbsp;&nbsp;Hrs Left</th><th>&nbsp;&nbsp;Hrs Updated</th>
			</tr>");
	
		// print employees and the status of the timesheets for the pay period
		while($count > 0)
		{
			// since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at employeename_store[0]
			$count = $count - 1;
			
			// check to see if status if submitted or approved, default to image for false
			$submitimage = "alert.gif";
			$approveimage = "alert.gif";
			
			// is submit timestamp has value, set submitted image to true
			if(!is_null($submit_store[$count]))
			{
				$submitimage = "statusfine.gif";
			}
			// if approve timestamp has value, set approve image to true
			if(!is_null($approve_store[$count]))
			{
				$approveimage = "statusfine.gif";
			}
			
			// convert date to more readable text, if hrs left = 9999 then non-work study student
			$updatetime = "";
			$hrstime;
			$hrsclass = "";
			if($hrs_store[$count] != 9999)
			{
				// then work study student
				$updatetime = date("m/d/Y", strtotime($hrsupdated_store[$count]));
				$hrstime = $hrs_store[$count];
				
				// check if hrs lower than threshold, if so color field
				if($hrstime < 60)
				{
					$hrsclass = "nonprintwarning";
				}
			}
			else
			{
				// then non-work study student, set hours to NA
				$hrstime = "NA";
			}
			
                        //get email address
                        $emailaddressemployee = getUserEmail($employeeuser_store[$count]);
                        
			
			print("	
			<tr>
			  <!-- add email button with unique names and mouse rollover effect -->
			  <td>
				<a href=\"mailto:$emailaddressemployee\" onMouseover=\"document.employeeemail$count.src='email_buttongrayover.gif'\" onMouseout=\"document.employeeemail$count.src='email_buttongray.gif'\">
				<img src=\"email_buttongray.gif\" name=\"employeeemail$count\" class=\"styleimage\" alt=\"emailicon\"></a></td>
			  <!-- add employee name as a stylized input button linked to the timesheet to review it -->
			  <td>
				<input type=\"submit\" value=\"$employeename_store[$count]\" name=\"review$count\" class=\"stylebutton\" onmouseover=\"this.className='stylebuttonover'\" onmouseout=\"this.className='stylebutton'\">
				<input type=\"hidden\" value=\"$payid_store[$count]\" name=\"payidstore$count\">
			  </td>
			  <!-- add submitted status icon -->
			  <td>
				<img src=\"$submitimage\" alt=\"submitstatus\">
			  </td>
			  <!-- add approved status icon -->
			  <td> 
				<img src=\"$approveimage\" alt=\"approvestatus\">
			  </td>
			  <!-- add remaining work study hrs left -->
			  <td>
				<p class=\"$hrsclass\">$hrstime</p>
			  </td>
			  <!-- show when hrs last updated -->
			  <td>
				$updatetime
			  </td>
			</tr>
			");
		}//endwhile
		
		print("</table>");
			
	}//endelse employees have saved
	
	// print end of table
	print("	
		</center>");
	
	// print end of form
	print("</form>\n\n");
	
	// print usage notes
	print("<div id=\"notes\">");
	
	// print notification if no timesheets saved
	if($nosheets)
	{
		print("<p><font color=\"red\">**</font>If you do not see any timesheets you may be looking at the wrong pay period or no employees have saved timesheets for this period. To look at the last pay period use the drop down menu above. The pay period ends Saturday at 11:59 PM. If this is the correct pay period, please ensure that your employee list below is correct and contact the employee if a timesheet is expected. <font color=\"red\">**</font></p>");
	}
	print("	
	<!-- display usage notes -->
	<p>Click on an employee's name to review their timesheet for the period and approve it. Press \"Change\" to view another pay period. \"Hrs Left\" represents the number of work study hours remaining as of the last update, given in the \"Hrs Updated\" column. This number may be out of date if not recent and should serve as a general guideline only.</p>
	
	<p>For questions contact administrative staff at <a href=\"mailto:$hrtoaddress\">$hrtoaddress</a>.</p>\n
	</div>\n");
	
	// print symbol legend
	
	print("<div id=\"legend\"> 
	<table>
	<tr><td><img src=\"statusfine.gif\" alt=\"fine\"></td><td>indicates that the step is completed.</td></tr> 
	<tr><td><img src=\"alert.gif\" alt=\"alert\"></td><td>indicates that the step is not yet complete.</td></tr> 
	<tr><td><img src=\"email_buttongray.gif\" alt=\"email\"></td><td>click to email the employee.</td></tr>
	</table>
	</div>\n\n");
	
	// print employees list for supervisor
	
	print("<div id=\"list\">
	<p><b>Employees Supervised</b><br><br>");
	
	while($listcount > 0)
	{
		// since array is zero indexed, minus 1 (i.e. count = 1 then one value stored at listemployee_store[0]
		$listcount = $listcount - 1;
		
		// print employee name
		print("$listemployee_store[$listcount]<br>");	
	}
	
	// print end of employee list table
	print("</p>
	</div>\n\n");
	
	// print footer
	print("<div id=\"footer\"><br><br></div>\n\n");
	
    }//end account not disabled
}//end require auth else
?>
		<!--end content container-->
		</div>
	<!--end container-->
	</div>
</body>
</html>

